<?php
// myPHPCalendar - Online Calendaring Software
// Copyright (C) 2000 David van der Bokke

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// globals.inc
// This file supports most of the functionality of the calendar.
// It contains all of the functions used to display and order data
// as well as security functions.

include($cal_dir."vars.inc");
include($cal_dir."prefs.inc");
$version = "10192000 Build 1 BETA";
$contactscript = $cal_dir."contacts.php";
$adminscript = $cal_dir."admin.php";

// Determine whether the setup file exists, if it does not then error out.
if (file_exists($cal_dir.'setup.inc')) {
        include($cal_dir.'setup.inc');
} else {
        die ("Error: setup.inc not found");
}

include($cal_dir."lang/".$language.".inc");
function nice_exit() {
        global $conn, $starttime;
	$timeparts = explode(" ",microtime());
        $endtime = $timeparts[1].substr($timeparts[0],1);
        echo round(($endtime-$starttime),3)." seconds to execute";
        if (function_exists(session_stop)) session_stop();
        sql_close($conn);
        exit;
}

// This function prints out the basic html headers
function print_header($title, $jscript = "") {
        global $cdaycolor, $cell, $tcellcolor, $ttextcolor, $cellspacing, $bordercolor, $bordersize, $cellcolor, $background_color, $background_image, $rep_once_types, $daynames;
        echo "<html><head>\n<title>$title</title>\n";
        if (! empty($jscript)) {
                include ($jscript);
        }
        echo "<STYLE TYPE=\"text/css\">\n";
        include ('style.css');
        echo "</style>";
        // echo "<link rel=\"stylesheet\" href=\"style.css\" type=\"text/css\">";
        echo "</head><body>";
}

// This function prints a logout link
function print_logout($sid) {
        global $mainscript;
                global $logout, $menu_delimiter;
        echo "<a
href=\"$mainscript?Logout=1&sess_id=$sid\">$logout</a>$menu_delimiter\n";
}

// This function prints an options link
function print_options($sid) {
        global $mainscript;
        global $options, $menu_delimiter;
        echo "<a href=\"$mainscript?UPDOPT=0&sess_id=$sid\">$options</a>$menu_delimiter\n";
}

// This functions prints out the menu for Calendar Options
function print_options_menu($sid) {
        global $mainscript;
        global $calendar_options, $first_name, $description, $user_options, $group_options, $edit_user, $edit_group, $optionsm, $edit_nagroups, $nagroup_options;
        echo "<h4>$calendar_options</h4>\n";
        include ("options.inc");
}

// This function prints a new date link
function print_newdate($sid) {
        global $mainscript;
        global $new_date, $menu_delimiter;
        echo "<a href=\"$mainscript?DATEADD=1&sess_id=$sid\">$new_date</a>$menu_delimiter\n";
}

// This function prints out the full month calendar
function print_calendar($date) {
        global $daynames;
        global $mainscript;
        global $cell;
        global $tcellcolor;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $week_begin;
        global $monthnames;
        $ccolor = "WHITE";
        $sid = session_id();
        echo "<table height=100% border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\"><tr bgcolor=\"$tcellcolor\" padding = 1>\n";
        if ($date[mon] == 1) {
                $mth = 12;
                $year = $date[year] - 1;
        } else {
                $mth = $date[mon] - 1;
                $year = $date[year];
        }
        $tmp = $date[mon];
        echo "<td colspan = 1 class=\"headerText\"><a href = \"$mainscript?sess_id=$sid&month=$mth&year=$year&PRINTCAL=1\">&lt;&lt;</a></td>\n";
        echo "<td colspan = 5 class=\"headerText\"><center>$monthnames[$tmp] $date[year]</center></td>\n";
        if ($date[mon] == 12) {
                $mth = 1;
                $year = $date[year] + 1;
        } else {
                $mth = $date[mon] + 1;
                $year = $date[year];
        }
        echo "<td colspan = 1 class=\"headerText\"><a href = \"$mainscript?sess_id=$sid&month=$mth&year=$year&PRINTCAL=1\">&gt;&gt;</a></td></tr>\n";
        echo "<tr bgcolor=\"$tcellcolor\" padding = 1>\n";
        for ($x = $week_begin; $x <= 7; $x++) {
                echo "<td class=\"headerText\">$daynames[$x]</td>\n";
        }
        for ($x = 1; $x < $week_begin; $x++) {
                echo "<td class=\"headerText\">$daynames[$x]</td>\n";
        }
        echo "</tr>\n";
        $max = date("t", mktime(0, 0, 0, $date[mon], 1, $date[year]));
        $dt[mday] = $date[mday];
        for ($x = 1; $x <= $max; $x++) {
                $day = date("l", mktime(0, 0, 0, $date[mon], $x, $date[year]));
                $daynum = date("w", mktime(0, 0, 0, $date[mon], $x, $date[year])) + 1;
                $dt[day] = $x;
                $dt[month] = $date[mon];
                $dt[year] = $date[year];
                if ($x == 1) {
                        echo "<tr bgcolor = \"$ccolor\">\n";
                        $d = $week_begin;
                        while ($daynum != $d) {
                                echo "<td height = $cell>&nbsp</td>\n";
                                $d++;
                        }
                        if ($daynum == $d) {
                                print_day($dt, $cell);
                        }

                } elseif ($daynum == $week_begin) {
                        echo "</tr><tr bgcolor = \"$ccolor\">\n";
                        print_day($dt, $cell);
                } else {
                        print_day($dt, $cell);
                }
        }
        $x = $x - 6;

        $daynum = date("w", mktime(0, 0, 0, $date[mon], $x, $date[year]));
        while ($daynum != $week_begin) {
                echo "<td height = $cell>&nbsp</td>\n";
                $x++;
                $daynum = date("w", mktime(0, 0, 0, $date[mon], $x, $date[year]));
        }
        echo "</table>";
}

// This function is deprecated since the use of sql.inc
function mysql_command($query) {
        if ($query != "") {
                list($cnt, $rows) = sql_query("$query");
                $row = sql_fetch_array($cnt, 0);
                sql_free_result($cnt);
                return $row;
        }
}

// This function is called from print_calendar in order to print out the
// content of a single day
// New Print_Day code

function print_day($date, $cell) {
        global $cdaycolor;
        global $monthnames;
        global $mainscript;
        global $uid;
        global $maxdisplay;
        global $spcl;
        global $clock_type;
        $date[mon] = $date[month];
        $date[month] = $monthnames[$date[month]];
        $tmp = get_cal_items($date, $uid);
        $sitems = $tmp[0];
        $items = $tmp[1];
        if ($maxdisplay > 0 && count($items) > $maxdisplay) {
                $total = count($items);
                $tmp = getdate();
                $time = mktime($tmp[hours], $tmp[minutes], 0, 0, 0, 0);
                for ($x = 0; $x < $total; $x++) {
                        $row = $items[$x];
                        if ($row[datetime] >= $time) {
                                $limit_item = $x;
                                break;
                        }
                }
                if ($limit_item < $maxdisplay) {
                        $limit_item = $total - $maxdisplay - 1;
                }
                for ($x = $limit_item; $x < $limit_item + $maxdisplay + 1; $x++) {
                        $row = $items[$x];
                        $d = count($items1);
                        $items1[$d] = $row;
                }
                reset($items1);
                $items = $items1;
        }
        $sid = session_id();
        if ($date[mday] == $date[day]) {
                echo "<td class=\"today\" height = $cell valign = top><a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$date[day]\">$date[day]</a>\n";
        } else {
                echo "<td height = $cell valign = top><a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$date[day]\">$date[day]</a>\n";
        }
        for ($d = 0; $d < count($items) + count($sitems); $d++) {
                if ($d >= count($sitems)) {
                        $row = $items[$d - count($sitems)];
                } else {
                        $row = $sitems[$d];
                }
                                echo "<br>\n";
                                $date1 = getdate($row[datetime]);
                                if ($date1[minutes] == 0) $date1[minutes] = "00";
                                if (strlen($date1[minutes]) == 1) $date1[minutes] = "0$date1[minutes]";
                                if ($clock_type == 1) {
                                        if ($date1[hours] >= 12) $ampm = "pm";
                                        if ($date1[hours] < 12) $ampm = "am";
                                        if ($date1[hours] > 12) $date1[hours] -= 12;
                                        if ($date1[hours] == 0) $date1[hours] = 12;
                                } elseif ($clock_type == 2) {
                                        $ampm = "";
                                }
                                if ($row[special] == 0) {
                                        echo "<span class=\"time\">$date1[hours]:$date1[minutes]$ampm </span><a href = \"$mainscript?sess_id=$sid&VIEWDATE=1&id=$row[id]&month=$date[mon]&day=$date[day]&year=$date[year]\">$row[title]</a>\n";
                                } else {
                                        echo "<span class=\"special\">$spcl</span> <a href  = \"$mainscript?sess_id=$sid&VIEWDATE=1&id=$row[id]&month=$date[mon]&day=$date[day]&year=$date[year]\">$row[title]</a>\n";
                                }
                                echo $row[gimp];
        }
        $diff = $total - count($items);
        if ($diff > 0) echo "<br><a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$date[mday]\">$diff Item(s) left</a>";
        echo "</td>\n";
}

function get_cal_items($date, $uid) {
        if (! empty($uid)) {
                $username = sql_command("select username from users where id = $uid");
                $username = current($username);
        }
        $sid = session_id();
        $begin_stamp = mktime(0, 0, 0, $date[mon], $date[day], $date[year]);
        $end_stamp = mktime(0, 0, 0, $date[mon], $date[day] + 1, $date[year]);
        $query = "select * from calendar where datetime >= $begin_stamp and datetime < $end_stamp and datetime < $end_stamp and special = 0 and recurrence = 0 and title <> 'Deleted' order by datetime";
        list($result, $rows) = sql_query($query);
        for ($d = 0; $d < $rows; $d++) {
                $row = sql_fetch_array($result, $d);
                $tmp = getdate($row[datetime]);
                $row[time] = mktime($tmp[hours], $tmp[minutes], 0, 0, 0, 0);
                $items[$d] = $row;
        }
        sql_free_result($result);
        $query = "select * from calendar where datetime >= $begin_stamp and datetime < $end_stamp and special = 1 and recurrence = 0 and title <> 'Deleted' order by datetime";
        list($result, $rows) = sql_query($query);
        for ($d = 0; $d < $rows; $d++) {
                $row = sql_fetch_array($result, $d);
                $sitems[$d] = $row;
        }
        sql_free_result($result);
        // Select ALL items between start date and end date with current day # as a recurr_day..
        $dw = date('w', $begin_stamp) + 1;
        $query = "select * from calendar where startdate <= $begin_stamp and enddate >= $end_stamp and recurr_days like '%$dw%' and title <> 'Deleted'";
        list($result, $rows) = sql_query($query);
        for ($d = 0; $d < $rows; $d++) {
                $row = sql_fetch_array($result, $d);
                if ($row[recurrence] == 1) {
                        $tmp = $begin_stamp - $row[startdate];
                        $tmp = $tmp / (60 * 60 * 24 * 7);
                        $verif = intval($tmp) / 2;
                        if (strcmp(trim(gettype($verif)), "integer") == 0) {
                                $d = count($ritems);
                                $tmp = getdate($row[datetime]);
                                $row[time] = mktime($tmp[hours], $tmp[minutes], 0, 0, 0, 0);
                                $ritems[$d] = $row;
                        }
                } elseif ($row[recurrence] == 2) {
                        $res = date('j', $begin_stamp);
                        $res = $res - (($row[recurr_options] - 1) * 7);
                        if ($res > 0 and $res <= 7) {
                                $d = count($ritems);
                                $tmp = getdate($row[datetime]);
                                $row[time] = mktime($tmp[hours], $tmp[minutes], 0, 0, 0, 0);
                                $ritems[$d] = $row;
                        }
                } elseif ($row[recurrence] == 3) {
                        $d = count($ritems);
                        $tmp = getdate($row[datetime]);
                        $row[time] = mktime($tmp[hours], $tmp[minutes], 0, 0, 0, 0);
                        $ritems[$d] = $row;
                }
        }
        sql_free_result($result);
	// Select ALL items that have a yearly recurrence for this day
	$recurrmth = date('n', $begin_stamp);
	$recurrday = date('j', $begin_stamp);
	$yeardaystamp = mktime(0, 0, 0, $recurrmth, $recurrday, 1970);
	$query = "select * from calendar where startdate <= $begin_stamp and recurrence like '4' and enddate like '$yeardaystamp' and title <> 'Deleted'";
	list($result, $rows) = sql_query($query);
        for ($d = 0; $d < $rows; $d++) {
		$row = sql_fetch_array($result, $d);
		$d = count($ritems);
		$tmp = getdate($row[datetime]);
		$row[time] = mktime($tmp[hours], $tmp[minutes], 0, 0, 0, 0);
		$ritems[$d] = $row;
	}
	sql_free_result($result);

        for ($x = 0; $x < count($ritems); $x++) {
                $row = $ritems[$x];
                if ($row[special] == 1) {
                        $d = count($sitems);
                        $sitems[$d] = $ritems[$x];
                } else {
                        $d = count($items);
                        $items[$d] = $ritems[$x];
                }
        }
        // Sort array.. ordered by time..
        for ($x = 0; $x < count($items); $x++) {
                $tmp = $items[$x];
                $itemtmp[$x] = $tmp[time];
        }
        if (is_array($itemtmp)) {
                asort($itemtmp);
                reset($itemtmp);
                for ($x = 0; $x < count($itemtmp); $x++) {
                        $key = key($itemtmp);
                        $items1[$x] = $items[$key];
                        next($itemtmp);
                }
                $items = $items1;
        }

        for ($d = 0; $d < count($items) + count($sitems); $d++) {
                if ($d >= count($sitems)) {
                        $row = $items[$d - count($sitems)];
                } else {
                        $row = $sitems[$d];
                }
                if (strcmp($row[title], "Deleted") != 0) {
                        if (strcmp("g", $row[permissions][0]) == 0) {
                                $temp = split(":", $row[permissions]);
                                $row[permissions] = "";
                                for ($x = 1; $x < count($temp); $x++) {
                                        $b = (int) trim($temp[$x]);
                                        $tmp = sql_command("select users from groups where id = $b");
                                        $tmp = $tmp[users];
                                        $row[permissions] = "$row[permissions]$tmp";
                                }
                        }
                        if (isset($uid) && ! empty($uid) && $uid != 0) {
                                $perm = sql_command("select permissions from users where id = $uid");
                                $perm = current($perm);
                        }
                        if (strcmp($row[permissions], "*") == 0 || check_canread_date($uid, $row[permissions]) == 1 || strcmp($perm, "ga") == 0) {
                                if ($row[special] == 1) {
                                        $a = count($sitems2);
                                        $sitems2[$a] = $row;
                                } else {
                                        $a = count($items2);
                                        $items2[$a] = $row;
                                }
                        }
                } else {

                }
        }
        $temp[0] = $sitems2;
        $temp[1] = $items2;
        return $temp;
}


// This function prints out the single day view
function print_this_day($date) {
        global $cdaycolor;
        global $monthnames;
        global $mainscript;
        global $uid;
        global $tcellcolor;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $event_time;
        global $spcl;
        global $clock_type;
        $sid = session_id();
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\"><tr bgcolor = $tcellcolor><td width = 40 class=\"headerText\">$event_time</td>\n";
        echo "<td width = 400 class=\"headerText\">$title</td>\n";
        $tmp = get_cal_items($date, $uid);
        $sitems = $tmp[0];
        $items = $tmp[1];
        for ($d = 0; $d < count($items) + count($sitems); $d++) {
                if ($d >= count($sitems)) {
                        $row = $items[$d - count($sitems)];
                } else {
                        $row = $sitems[$d];
                }
                echo "<tr>\n";
                $date = getdate($row[datetime]);
                if ($clock_type == 1) {
                        if ($date[hours] >= 12) $ampm = "pm";
                        if ($date[hours] < 12) $ampm = "am";
                        if ($date[hours] > 12) $date[hours] -= 12;
                        if ($date[hours] == 0) $date[hours] = 12;
                } else {
                        $ampm = "";
                }
		$date[day] = $date[mday];
                if ($date[minutes] == 0) {
                        $date[minutes] = "00";
                }
                if (strlen($date[minutes]) == 1) $date[minutes] = "0$date[minutes]";
                if ($row[special] == 0) {
                        echo "<td><span class=\"time\">$date[hours]:$date[minutes]$ampm</span></td><td><a href = \"$mainscript?sess_id=$sid&VIEWDATE=1&id=$row[id]&month=$date[mon]&day=$date[day]&year=$date[year]\">$row[title]</a></td>\n";
                } elseif ($row[special] == 1) {
                        echo "<td><span class=\"special\">$spcl</span></td><td><a href = \"$mainscript?sess_id=$sid&VIEWDATE=1&id=$row[id]&month=$date[mon]&day=$date[day]&year=$date[year]\">$row[title]</a></td>\n";
                }
        }
        echo "</table>";
}

// This function prints out the data for one day during the period loop
function print_period_day($date1) {
        global $cdaycolor;
        global $monthnames;
        global $mainscript;
        global $uid;
        global $tcellcolor;
        global $spcl;
        global $clock_type;
        $tmp = get_cal_items($date1, $uid);
        $sitems = $tmp[0];
        $items = $tmp[1];
        $sid = session_id();
        $printed_date = 0;
        for ($d = 0; $d < count($items) + count($sitems); $d++) {
                if ($d >= count($sitems)) {
                        $row = $items[$d - count($sitems)];
                } else {
                        $row = $sitems[$d];
                }
                $date = getdate($row[datetime]);
                                if ($printed_date == 0) {
                                        $printed_date = 1;
                                        $tmp = $date1[mon];
                                        echo "<tr><td colspan = 2 bgcolor = $tcellcolor class=\"headerText\">$monthnames[$tmp] $date1[day], $date1[year]</td>\n";
                                }
                                if ($clock_type == 1) {
                                        if ($date[hours] >= 12) $ampm = "pm";
                                        if ($date[hours] < 12) $ampm = "am";
                                        if ($date[hours] > 12) $date[hours] -= 12;
                                        if ($date[hours] == 0) $date[hours] = 12;
                                } else {
                                        $ampm = "";
                                }
                                if ($date[minutes] == 0) {
                                        $date[minutes] = "00";
                                }
                                if (strlen($date[minutes]) == 1) $date[minutes] = "0$date[minutes]";
                                if ($row[special] == 1) {
                                        echo "<tr><td><span class = \"special\">$spcl</span></td><td><a href = \"$mainscript?sess_id=$sid&VIEWDATE=1&id=$row[id]\">$row[title]</a></td>\n";
                                } else {
                                        echo "<tr><td><span class=\"time\">$date[hours]:$date[minutes]$ampm</span></td><td><a href = \"$mainscript?sess_id=$sid&VIEWDATE=1&id=$row[id]\">$row[title]</a></td>\n";
                                }
        }
}

// This function is deprecated since 02262000 Build 1
function make_order_array($array) {
        for ($ct = 1; $ct <= count($array); $ct++) {
                $temp = split(",", $array[$ct][time]);
                $tt = split(":", $temp[0]);
                $temp[0] = $tt[0];
                $ampm = $temp[1];
                if (empty($tt[1])) {
                        $temp[1] = 00;
                } else {
                        $temp[1] = $tt[1];
                }
                if (strcmp($ampm, "pm") == 0 && $temp[0] != 12) {
                        $temp[0] += 12;
                } elseif (strcmp($ampm, "am") == 0 && $temp[0] == 12) {
                        $temp[0] = 0;
                }
                $unixtime = mktime($temp[0], $temp[1], 0, 3, 3, 2000);
                if (! empty($timestamps)) {
                        reset($timestamps);
                        while (key_in_array($timestamps, $unixtime) == 1) {
                               $unixtime = $unixtime + 1;
                        }
                }
                $timestamps[$unixtime] = $ct;
        }
        return $timestamps;
}

// This function is deprecated since 02262000 Build 1
function key_in_array($arr, $key1) {
        reset($arr);
        $yes = 0;
        while (list($key, $val) = each($arr)) {
                if ($key == $key1) {
                        $yes = 1;
                }
        }
        return $yes;
}

// This function prints out the small calendar on the side of the single
// day view
function print_small_calendar($date) {
        global $daynames;
        $sid = session_id();
        global $mainscript;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $week_begin;
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\">\n";
        echo "<tr><td colspan = 7><center>";
        $tmp = $date[mon] - 1;
        echo "<a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$date[mday]&cmonth=$tmp\">";
        echo "&lt;&lt; </a>$date[month] ";
        $tmp = $date[mon] + 1;
        echo "<a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$date[mday]&cmonth=$tmp\">";
        echo "&gt;&gt;</a></center></td>\n";
        $max = date("t", mktime(0, 0, 0, $date[mon], 1, $date[year]));
        $dt[mday] = $date[mday];
        for ($x = 1; $x <= $max; $x++) {
                $day = date("l", mktime(0, 0, 0, $date[mon], $x, $date[year]));
                $daynum = date("w", mktime(0, 0, 0, $date[mon], $x, $date[year])) + 1;
                $dt[day] = $x;
                $dt[month] = $date[mon];
                $dt[year] = $date[year];
                if ($x == 1) {
                        echo "<tr bgcolor = \"$ccolor\">\n";
                        $d = $week_begin;
                        while ($daynum != $d) {
                                echo "<td height = $cell>&nbsp</td>\n";
                                $d++;
                        }
                        if ($daynum == $d) {
                                echo "<td><a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$x\">$x</a></td>\n";
                        }
                } elseif ($daynum == $week_begin) {
                        echo "</tr><tr bgcolor = \"$ccolor\">\n";
                        echo "<td><a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$x\">$x</a></td>\n";
                } else {
                        echo "<td><a href = \"$mainscript?sess_id=$sid&VIEWLITTLE=1&month=$date[mon]&year=$date[year]&day=$x\">$x</a></td>\n";
                }
        }
        $x = $x - 6;
        $daynum = date("w", mktime(0, 0, 0, $date[mon], $x, $date[year]));
        while ($daynum != $week_begin) {
                echo "<td height = $cell>&nbsp</td>\n";
                $x++;
                $daynum = date("w", mktime(0, 0, 0, $date[mon], $x, $date[year]));
        }
        echo "</h6></table>\n";
}

// This function determines whether a user can read an item or not(Security)
function check_canread_date($uname, $string) {
        $temp = split(":", $string);
        $res = 0;
        $x = 0;
        while (strcmp($temp[$x], $uname) != 0 && $x != count($temp)) {
                $x++;
        }
        if (strcmp($temp[$x], $uname) == 0 && strcmp($temp[$x], "") != 0) {
                $res = 1;
        }
        return $res;
}

// This function prints a login prompt
function print_login($sid) {
        global $tcellcolor;
        global $mainscript;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $login;
        global $user_name, $a_password;
        echo "<form action = \"$mainscript?sess_id=$sid&LOGIN=1\" method = post>\n";
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\"><tr><td valign = top bgcolor = \"$tcellcolor\" colspan = 2 class=\"headerText\">$login</td>";
        echo "<tr><td valign = top>$user_name</td>\n<td valign = top><input type = text name = \"UNAME\"></td>\n";
        echo "<tr><td valign = top>$a_password</td>\n<td valign = top><input type = password name = \"PW\"></td>\n";
        echo "<tr><td colspan = 2 valign = top><center><input type = submit value = \"$login\"></center></td></table>\n";
}

// This function prints a new user page
function print_newuser($sid) {
        global $mainscript;
        global $first_name, $last_name, $e_mail, $login, $a_password, $go_button, $reset, $user_name;
        echo "<center>";
        echo "<form action=\"$mainscript?sess_id=$sid\" method=\"post\">\n";
        echo "<input type=\"hidden\" name=\"ADD\" value=1>\n";
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\"><tr><td valign = top bgcolor = \"$tcellcolor\" colspan = 2 class=\"headerText\">$login</td>";
        echo "<tr><td valign = top>$first_name</td><td><input type=\"text\" name = \"FNAME\" cols=100><br></td>\n";
        echo "<tr><td valign = top>$last_name</td><td><input type=\"text\" name = \"LNAME\" cols=100><br></td>\n";
        echo "<tr><td valign = top>$e_mail</td><td><input type=\"text\" name = \"EMAIL\" cols = 100><br></td>\n";
        echo "<tr><td valign = top>$user_name</td><td><input type=\"text\" name = \"UNAME\" cols=100><br></td>\n";
        echo "<tr><td valign = top>$a_password</td><td><input type=\"password\" name = \"PW\" cols=100><br></td>\n";
        echo "<tr><td colspan = 2><center><input type=\"submit\" value = \"$go_button\"><input type=\"reset\" value=\"$reset\"></center></td></table></form>\n";
        echo "</center>";
}

// This function prints the Date Select box on the full calendar view
function print_dateselect($month, $year, $sid) {
        global $mainscript;
        global $monthnames;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $a_month, $a_year, $go_button;
        echo "<form action = \"$mainscript?sess_id=$sid&PRINTCAL=1\" method = POST>\n";
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\">";
        echo "<tr><td valign = top>$a_month</td><td valign = top><select name = \"month\">\n";
        for ($x = 1; $x <= 12; $x++) {
                if ($month == $x) {
                        echo "<option value = \"$x\" selected>$monthnames[$x]\n";
                } else {
                        echo "<option value = \"$x\">$monthnames[$x]\n";
                }
        }
        echo "</select></td>";
        echo "<tr><td valign = top>$a_year</td><td valign = top><select name = \"year\">\n";
        for ($x = 2000; $x <= 2005; $x++) {
                if ($year == $x) {
                        echo "<option value = \"$x\" selected>$x\n";
                } else {
                        echo "<option value = \"$x\">$x\n";
                }
        }
        echo "</select></td>";
        echo "<tr><td valign = top colspan = 2><center><input type = submit value = \"$go_button\"></center></td>\n";
        echo "</form></table>\n";
}

// Prints the input box for date searching..
function print_datesearch($sid) {
        global $mainscript;
        global $monthnames;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $go_button;
        global $search_for, $a_type, $subject, $details, $search_all;
        echo "<form action = \"$mainscript?sess_id=$sid&SEARCH=1\" method = POST>\n";
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\">\n";
        echo "<tr><td>$search_for</td>\n";
        echo "<td><input type = text name = \"stext\" size = 10></td>\n";
        echo "<tr><td>$a_type</td><td><select name = \"search_type\">\n";
        echo "<option value = 1>$subject</option>\n";
        echo "<option value = 2>$details</option>\n";
        echo "<option value = 3>$search_all</option>\n";
        echo "</select></td>\n";
        echo "<tr><td colspan = 2><center><input type = submit value = \"$go_button\"></center></td>";
        echo "</table>\n";
}

// Prints the input box for selecting a period of time to view
function print_viewperiod($month, $year, $sid) {
        global $mainscript;
        global $monthnames;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $end_day, $end_month, $end_year, $start_day, $start_month, $start_year, $go_button;
        echo "<form action = \"$mainscript?sess_id=$sid&VIEWPERIOD=1\" method = POST>\n";
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\">\n";
        echo "<tr><td valign = top>$start_month</td><td valign = top><select name = \"startmonth\">\n";
        for ($x = 1; $x <= 12; $x++) {
                if ($month == $x) {
                        echo "<option value = \"$x\" selected>$monthnames[$x]\n";
                } else {
                        echo "<option value = \"$x\">$monthnames[$x]\n";
                }
        }
        echo "</select></td>";
        echo "<tr><td valign = top>\n";
        echo "$start_year</td><td valign = top>\n";
        echo "<select name = \"startyear\">\n";
        $date = date("Y", mktime());
        for ($x = $date; $x <= $date + 5; $x++) {
                if ($year == $x) {
                        echo "<option value = \"$x\" selected>$x\n";
                } else {
                        echo "<option value = \"$x\">$x\n";
                }
        }
        echo "</select></td>";
        echo "<tr><td valign = top>$start_day</td><td valign = top><input type = text name = \"startday\" value = 1 size = 4></td>\n";
        echo "<tr><td valign = top>$end_month</td><td valign = top><select name = \"endmonth\">\n";
        for ($x = 1; $x <= 12; $x++) {
                if ($month == $x) {
                        echo "<option value = \"$x\" selected>$monthnames[$x]\n";
                } else {
                        echo "<option value = \"$x\">$monthnames[$x]\n";
                }
        }
        echo "</select></td>";
         echo "<tr><td valign = top>\n";
        echo "$end_year</td><td valign = top>\n";
        echo "<select name = \"endyear\">\n";
        $date = date("Y", mktime());
        for ($x = $date; $x <= $date + 5; $x++) {
                if ($year == $x) {
                        echo "<option value = \"$x\" selected>$x\n";
                } else {
                        echo "<option value = \"$x\">$x\n";
                }
        }
        echo "</select></td>";
        echo "<tr><td valign = top>$end_day</td><td valign = top><input type = text name = \"endday\" value = 1 size = 4></td>\n";
        echo "</select>";
        echo "<tr><td colspan = 2 valign = top><center><input type = submit value = \"$go_button\"></center></td>\n";
        echo "</form>\n</table>";
}

// Prints out the html for the single day view.
function print_little_cal($date) {
        echo "<h4>Items for $date[month] $date[day], $date[year]</h4>\n";
        echo "<table><tr><td width = 500 valign = top>\n";
        print_this_day($date);
        echo "</td><td valign = top>\n";
        print_small_calendar($date);
        echo "</td></table>";
}

// Prints out all of the items on the full month view(including period
// select and date select)
function print_all_cal($date, $sid) {
        global $tcellcolor;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $select_date;
        global $view_period;
        global $view_datesearch;
        echo "<table><td valign = top>";
        print_calendar($date);
        echo "</td><td valign = top>";
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\"><tr><td bgcolor = \"$tcellcolor\" class=\"headerText\"><center>$select_date</center></td>\n";
        echo "<tr><td>\n<center>";
        print_dateselect($date[mon], $date[year], $sid);
        echo "</center></td>\n";
        echo "<tr><td bgcolor = \"$tcellcolor\" class=\"headerText\"><center>$view_period</center></td>\n";
        echo "<tr><td>";
        print_viewperiod($date[mon], $date[year], $sid);
        echo "</td><tr><td bgcolor = \"$tcellcolor\" class=\"headerText\"><center>$view_datesearch</center></td>\n";
        echo "<tr><td>\n";
        print_datesearch($sid);
        echo "</td></table>\n";
        echo "</td></table>";
}

function print_all_sideoptions($date, $sid) {
        global $tcellcolor;
        global $cellspacing;
        global $bordercolor;
        global $bordersize;
        global $select_date;
        global $view_period;
        global $view_datesearch;
        echo "<table border = $bordersize cellspacing=$cellspacing bordercolor=\"$bordercolor\"><tr><td bgcolor = \"$tcellcolor\" class=\"headerText\"><center>$select_date</center></td>\n";
        echo "<tr><td>\n<center>";
        print_dateselect($date[mon], $date[year], $sid);
        echo "</center></td>\n";
        echo "<tr><td bgcolor = \"$tcellcolor\" class=\"headerText\"><center>$view_period</center></td>\n";
        echo "<tr><td>";
        print_viewperiod($date[mon], $date[year], $sid);
        echo "</td><tr><td bgcolor = \"$tcellcolor\" class=\"headerText\"><center>$view_datesearch</center></td>\n";
        echo "<tr><td>\n";
        print_datesearch($sid);
        echo "</td></table>\n";
}

// This function determines whether a user is really logged in or whether
// someone is trying to hijack a user id.

//Disabled in the newest version with quick hacks.. no time to fix.
function check_LoggedIn($sid, $LoggedIn) {
        global $uid;
        global $crypt_type;
        $crypt_type = 4;
        $return = 1;
        if ($crypt_type == 1) {
                $UNAME = sql_command("select username from users where id = $uid");
                $UNAME = current($UNAME);
		if (function_exists(ob_start)) ob_start();
                $sess = mcrypt_ecb(MCRYPT_BLOWFISH, $sid, $UNAME, MCRYPT_ENCRYPT);
		if (function_exists(ob_end_clean)) ob_end_clean();
                if (strcmp($sess, $LoggedIn) == 0) $return = 0;
        } elseif ($crypt_type == 2) {
                $UNAME = sql_command("select username from users where id = $uid");
                $UNAME = current($UNAME);
                $sess = crypt($sid, $UNAME);
                if (strcmp($sess, $LoggedIn) == 0) $return = 0;
        } elseif ($crypt_type == 3) {
                $sess = base64_encode($sid);
                if (strcmp($sess, $LoggedIn) == 0) $return = 0;
        }
//        return $return;
        return 0;
}

function print_search_results($sid, $like) {
        global $uid;
        if (! empty($uid)) {
                $username = sql_command("select username from users where id = $uid");
                $username = current($username);
        }
        $query = "select * from calendar where special = 0 and title <> 'Deleted' and $like order by datetime";
        list($result, $rows) = sql_query($query);
        for ($d = 0; $d < $rows; $d++) {
                $row = sql_fetch_array($result, $d);
                $items[$d] = $row;
        }
        sql_free_result($result);
        $query = "select * from calendar where special = 1 and title <> 'Deleted' and $like order by datetime";
        list($result, $rows) = sql_query($query);
        for ($d = 0; $d < $rows; $d++) {
                $row = sql_fetch_array($result, $d);
                $sitems[$d] = $row;
        }
        sql_free_result($result);
        for ($d = 0; $d < count($items) + count($sitems); $d++) {
                if ($d >= count($sitems)) {
                        $row = $items[$d - count($sitems)];
                } else {
                        $row = $sitems[$d];
                }
                if (strcmp($row[title], "Deleted") != 0) {
                        if (strcmp("g", $row[permissions][0]) == 0) {
                                $temp = split(":", $row[permissions]);
                                $row[permissions] = "";
                                for ($x = 1; $x < count($temp); $x++) {
                                        $b = (int) trim($temp[$x]);
                                        $tmp = sql_command("select * from groups where id = $b");
                                        $tmp = $tmp[users];
                                        $row[permissions] = "$row[permissions]$tmp";
                                }
                        }
                        if (isset($uid) && ! empty($uid) && $uid != 0) {
                                $perm = sql_command("select permissions from users where id = $uid");
                                $perm = current($perm);
                        }
                        if (strcmp($row[permissions], "*") == 0 || check_canread_date($uid, $row[permissions]) == 1 || strcmp($perm, "ga") == 0) {
                                if ($row[special] == 1) {
                                        $a = count($sitems2);
                                        $sitems2[$a] = $row;
                                } else {
                                        $a = count($items2);
                                        $items2[$a] = $row;
                                }
                        }
                } else {

                }
        }
        $temp[0] = $sitems2;
        $temp[1] = $items2;
        return $temp;
}

function register_prefs($sid, $uid) {
        global $cdaycolor, $cell, $tcellcolor, $ttextcolor, $cellspacing, $bordercolor, $bordersize, $cellcolor, $background_color, $background_image, $language;
        global $added_user_prefs;
        $result = sql_command("select * from user_prefs where id = $uid");
        if (empty($result)) {
                sql_query("insert into user_prefs (id, cdaycolor, cell, tcellcolor, ttextcolor, cellspacing, bordercolor, bordersize, cellcolor, background_color, background_image, language) values ($uid, '$cdaycolor', '$cell', '$tcellcolor', '$ttextcolor', '$cellspacing', '$bordercolor', '$bordersize', '$cellcolor', '$background_color', '$background_image', '$language')");
                echo "<font color = blue><h4>$added_user_prefs</h4></font>";
        } else {
                $cdaycolor = $result[cdaycolor];
                $cell = $result[cell];
                $tcellcolor = $result[tcellcolor];
                $ttextcolor = $result[ttextcolor];
                $cellspacing = $result[cellspacing];
                $bordercolor = $result[bordercolor];
                $bordersize = $result[bordersize];
                $cellcolor = $result[cellcolor];
                $background_color = $result[background_color];
                $background_image = $result[background_image];
                $language = $result[language];
        }
}

function is_in_group($uid, $group) {
        $users = sql_command("select users from groups where id = $group");
        if (is_array($users)) {
                $tmp = explode(":", current($users));
                while (list($key, $val) = each($tmp)) {
                        if ($val == $uid) {
                                return true;
                                break;
                        }
                }
        }
        return false;
}

function is_in_nagroup($uid, $group) {
        $users = sql_command("select na_users from groups where id = $group");
        if (is_array($users)) {
                $tmp = explode(":", current($users));
                while (list($key, $val) = each($tmp)) {
                        $tmp1 = explode(";;;", $val);
                        if ($tmp1[0] == $uid) {
                                return true;
                                break;
                        }
                }
        }
        return false;
}

function guser_status ($uid, $groupid) {
        list($result, $rows) = sql_query("select moderate, user, canwrite from groups where id = $groupid");
        $row = sql_fetch_array($result);
        sql_free_result($result);
        $write = explode(":", $row[canwrite]);
        $moderate = explode(":", $row[moderate]);
        if ($uid == $row[user]) {
                $status = 3;
        } else {
                $status = 0;
                while (list($key, $val) = each($moderate)) {
                        if ($uid == $val) {
                                if ($status < 2) $status = 2;
                        }
                }
                while (list($key, $val) = each($write)) {
                        if ($uid == $val) {
                                if ($status < 1) $status = 1;
                        }
                }
		if (is_in_group($uid, $groupid) == true) {
			if ($status < 1) $status = 0;
		} else {
			$status = "-1";
		}
        }
        return $status;
}

function is_in_array($array, $val) {
	for ($x = 0; $x <= count($array); $x++) {
		if ($val == $array[$x]) {
			return true;
			break;
		}
	}
	return false;
}

?>
