<?php
// myPHPCalendar - Online Calendaring Software
// Copyright (C) 2000 David van der Bokke

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// sql.inc
// This include provides SQL command abstraction so that myPHPCalendar
// can easily support more database types.
// mySQL, PostgreSQL and MS SQL Server 7 are currently supported.
	
	function sql_connect($server, $username, $password, $dbname) {
		global $db_type;
		if ($db_type == 1) {
			$conn = mysql_connect($server, $username, $password);
			mysql_select_db($dbname);
		} elseif ($db_type == 2) {
			$conn = pg_Connect("host=$server dbname=$dbname user=$username password=$password");	
		} elseif ($db_type == 3) {
			$conn = mssql_connect($server, $username, $password);
			mssql_select_db($dbname);
// ESPAS 02/03/2000
		} elseif ($db_type == 4) {
			$conn = ocilogon($username, $password, $dbname);
// ESPAS 02/03/2000
		}
		return $conn;
	}

	function sql_close($conn="") {
		global $db_type;
		if ($db_type == 1) {
			mysql_close($conn);
		} elseif($db_type == 2) {
			pg_Close($conn);
		} elseif($db_type == 3) {
			mssql_close($conn);
// ESPAS 02/03/2000
		} elseif($db_type == 4) {
			ocilogoff($conn);
// ESPAS 02/03/2000			
		}
	}
	
	function sql_query($query) {
		global $db_type;
		global $conn;
		if ($db_type == 1) {
			$query = eregi_replace("\"", "", $query);
			$result = mysql_query($query);
			if ($result != 1 && ! empty($result)) $rows = mysql_num_rows($result);
		} elseif($db_type == 2) {
			$result = pg_Exec($conn, $query);
			$rows = pg_NumRows($result);
		} elseif($db_type == 3) {
			$result = mssql_query($query);
			$rows = mssql_num_rows($result);
// ESPAS 02/03/2000
		} elseif($db_type == 4) {
			$result = OCIParse($conn, $query);
    			OCIExecute($result);
// recuperation du nombre de lignes resultat
// et on re-execute la requete pour les donnees dans le cas d'un SELECT
                        if (strtolower(substr($query,0,6)) == 'select') {
	    			$rows = OCIFetchStatement($result, $test);
    				OCIFreeStatement($result);
    				$result = OCIParse($conn, $query);
    				OCIExecute($result);
    			} else {
    				$rows = OCIRowCount($result);
    			}
// ESPAS 02/03/2000
		}
		$res[0] = $result;
		$res[1] = $rows;
		return $res;
	}
	
	function sql_free_result($result) {
		global $db_type;
		if ($db_type == 1) {
                        mysql_free_result($result);
                } elseif($db_type == 2) {
                	pg_FreeResult($result);
                } elseif($db_type == 3) {
			mssql_free_result($result);
// ESPAS 02/03/2000
                } elseif($db_type == 4) {
			OCIFreeStatement($result);
// ESPAS 02/03/2000
		}
	}

	function sql_fetch_array($result, $num=0) {
		global $db_type;
		if ($db_type == 1) {
			$row = mysql_fetch_array($result);
		} elseif ($db_type == 2) {
			$row = pg_Fetch_Array($result, $num);
		} elseif($db_type == 3) {
			$row = mssql_fetch_array($result);
// ESPAS 02/03/2000
		} elseif($db_type == 4) {
			$bidon = OCIFetchInto($result, &$row);
			$ncols = OCINumCols($result);
    			for ( $i = 1; $i <= $ncols; $i++ ) {
			        $row[strtolower(OCIColumnName($result,$i))] = trim($row[$i-1]);
    			}
// ESPAS 02/03/2000
		}
		return $row;
	}

	function sql_command($query) {
                global $db_type;
		global $conn;
                if ($db_type == 1) {
                        $result = mysql_query($query);
			if (! mysql_error()) {   
				$row = mysql_fetch_array($result);
				mysql_free_result($result);
			}
                } elseif($db_type == 2) {
			$result = pg_Exec($conn, $query);
			$rows = pg_NumRows($result);
			if ($rows > 0) { 
				$row = pg_Fetch_Array($result, 0);
			}
			pg_FreeResult($result);
                } elseif($db_type == 3) {
			$result = mssql_query($query);
			$rows = mssql_num_rows($result);
			if ($rows > 0) {
				$row = mssql_fetch_array($result);
			}
			mssql_free_result($result);
// ESPAS 02/03/2000
                } elseif($db_type == 4) {
			$result = OCIParse($conn, $query);
    			OCIExecute($result);
    			$rows = OCIFetchInto($result, &$row);
			$ncols = OCINumCols($result);
    			for ( $i = 1; $i <= $ncols; $i++ ) {
			        $row[strtolower(OCIColumnName($result,$i))] = trim($row[$i-1]);
    			}
			OCIFreeStatement($result);
// ESPAS 02/03/2000
		}
		return $row;
        }
?>
