<? $ph_sendmail = "/usr/sbin/sendmail -t";
   $ph_ForceDec = true;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 
 * Copyright (c) 1999 Holotech Enterprises (phorm@holotech.net)
 *
 * You may freely distribute this script as-is, without modifications,
 * and with the accompanying example files and documentation. You may use 
 * this script freely, and modify it for your own purposes. There is no 
 * charge for this script, but if you register it, you will:
 *
 *   1) Encourage me to continue developing it
 *   2) Automatically receive future releases
 *   3) Have free technical support for Phorm
 *   4) Earn my eternal gratitude
 *
 * To register, include at least your name and email address, and send 
 * US$10 to: 
 * 
 *      Alan Little
 *      Holotech Enterprises
 *      2753 Manchester Rd.
 *      Ann Arbor, Michigan  48104  USA
 * 
 * I hope you find this program useful. Aloha.
 *                                                 Alan Little
 *                                                 November 1999
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
Phorm Variables:

Phorm's configuration variables ($PHORM_) are summarized in Appendix 
B of the documentation. Internal variables ($ph_) are summarized here.

Abort    = Signals the rest of the script to stop processing
Admin    = Error message(s) to be emailed to the system administrator
af       = File handle of the acknowledgement template
aidx     = Index for traversing the argument array for the ONEOF criterion
Alerts   = Internal alert message(s)
aline    = A line from the ack template file
Args[]   = Any arguments for the current criterion
bh       = File handle of phormbase.txt
bline    = A line from phormbase.txt
Cards[]  = Associative array for converting credit card names to codes
chdir    = A directory from phormbase.txt to change to
Comments = Any comments on the current criterion line
Crit     = The current validation criterion
CType    = The value of the card type field (Visa, Amex, etc.)
CVal     = Indicates whether the credit card number is valid
ef       = File handle for the validation error message file
eline    = A line from the validation error message file
ErrFile  = Index into $ph_ErrFiles[] for which file to use
ErrLevel = The highest validation error level that's occurred
Errs     = Fatal error messages that are displayed to the visitor
fidx     = File index for loading validation error message files
FILES    = Indicates we're currently loading validation error message files
Files[]  = Array of validation error message file names
ForceDec = If true, the user must explicitly declare variables from the form
form     = A form name from phormbase.txt to compare with $PHORM_BASE
Home     = The user's Phorm directory
HTLink   = The link to holotech.net
HTTag    = The Phorm/Holotech tag for the end of email messages
ID       = The connection ID for MySQL logging
idx      = General-purpose index variable
key      = A throwaway to hold the key while traversing an array with each()
lf       = File handle of the log file
LogLine  = Holds the values of the variables to be logged
LogVars  = The list of variables to log, from $PHORM_LOGVAR
MaxFile  = The size of $ph_Files[]
mh       = File handle for phormconfigm.inc
mlin     = A line of the failure message
Msg      = The failure message for the current criterion
MsgLevel = The error level of the current criterion
nul      = Holds unimportant values temporarily
path     = A path from phormbase.txt
QString  = The query to submit to MySQL for logging
ReqHdr   = HTML header to output if a variable in $PHORM_REQ is missing
ReqVars  = The list of variables required in $PHORM_REQ
Result   = The result of the MySQL query
rf       = File handle of the responder template
rline    = A line from the responder template
RULES    = Indicates we're currently processing validation rules
selected = Indicates whether the MySQL database was successfully selected
sm       = Process handle for sendmail
tf       = File handle for the email template file
tkln     = Holds a line while it's being parsed for variable substitutions
tkn      = Holds the name of a variable to be substituted into the line
tline    = A line from the email template file
tmax     = The maximum number of items in $PHORM_TMPL[]
uh       = File handle for phormusers.txt
uline    = A line from phormusers.txt
varHold  = An array to hold $PHORM_ variables passed from the form
VarLock  = An array to hold $PHORM_ variables defined in phormconfigm.inc
Val      = The value of the variable being validated
val      = Holds variable values while processing the ForceDec directive
ValCat   = Holds values to be concatenated
ValMsg[] = Holds error messages for the various levels
Var      = The name of the variable being validated
var      = Holds variable names while processing the ForceDec directive
Vers     = The current version of Phorm
vf       = File handle for the VALDEFS file
vlin     = A line from the VALDEFS file
*/

/*
  Function to validate a credit card number with the Luhn Mod 10 formula.
  Returns true if the number is valid, false otherwise. */
  function ph_luhn($CCNum) {
    $Total = 0;
    $CCNum = strrev($CCNum);

    for ($x=0; $x<strlen($CCNum); $x++) {
      $digit = substr($CCNum,$x,1);
      if ($x/2 != floor($x/2)) {
        $digit *= 2;
        if (strlen($digit) == 2) 
          $digit = substr($digit,0,1) + substr($digit,1,1);
      }
      $Total += $digit;
    }
    if ($Total % 10 == 0) return true; else return false;
  }

/* 
  Debugging Function */
  function gdump() {
    global $ph_varHold, $HTTP_GET_VARS, $HTTP_POST_VARS,
           $HTTP_COOKIE_VARS, $argv;
    reset($GLOBALS);
    while (list($key, $val) = each($GLOBALS)) {
      if (trim($val) == "Array") {
        echo "<B>$key:</B><BR>";
        while (list($var, $val) = each($$key)) {
          echo "&nbsp;&nbsp;$val<BR>";
        }
      }
      else {
        echo "$key: $val<BR>";
      }
    }
    exit;
  }

/*
  Unset any ph_ variables to prevent anyone from trying to sneak something
  in (such as ph_debug variables!) */
  while (list($ph_var, $ph_val) = each($GLOBALS))
    if (ereg("^ph_", $ph_var) && !ereg("^ph_sendmail$|^ph_ForceDec$", $ph_var))
      unset($$ph_var);
  reset($GLOBALS);

  $ph_Vers = "Phorm v2.02";
  $ph_Home = dirname(getenv("PATH_TRANSLATED"));

/*
  Process phormbase.txt */
  if ($PHORM_BASE) {
    if ($ph_debug3) echo "<B>NS:</B> phormbase.inc<BR>";
    if (!is_readable("phormbase.txt")) {
      $ph_Errs.= "Unable to open file ".$ph_Home."phormbase.txt<BR><BR>\n";
      $ph_Abort = true;
    }
    else {
      $ph_bh = fopen("phormbase.txt", "r");
      while (!feof($ph_bh)) {
        $ph_bline = fgets($ph_bh, 256);
        list($ph_form, $ph_path) = explode("\t", trim($ph_bline));
        if ($ph_form == $PHORM_BASE) $ph_chdir = $ph_path;
      }
    }
  }
  unset($PHORM_BASE);

/*
  Record the configuration variables passed from the form, then unset them */
  if ($ph_ForceDec) {
    while (list($ph_var, $ph_val) = each($GLOBALS))
      if (ereg("^PHORM_", $ph_var)) {
        $ph_varHold[$ph_var] = $ph_val;
        unset($$ph_var);
      }
  }
  reset($GLOBALS);

/*
  Check for the phormconfig.inc file and process it */
  if (file_exists("phormconfig.inc")) {
    if ($ph_debug3) echo "<B>NS:</B> phormconfig.inc<BR>";
    if (!is_readable("phormconfig.inc")) {
      $ph_Errs.= "Unable to open main Phorm configuration file.<BR><BR>\n";
      $ph_Abort = true;
    }
    else {
      include ("phormconfig.inc");
    }
  }

/*
  Restore the value of PHORM_CONFIG */
  $PHORM_CONFIG = $ph_varHold["PHORM_CONFIG"];

/*
  If there was a match in phormbase.txt, change to the specified dir */
  if ($ph_chdir) {
    if ($ph_debug3) echo "<B>NS:</B> chdir($ph_chdir)<BR>";
    if (!@chdir($ph_chdir)) {
      $ph_Errs.= "Invalid directory <B>$ph_chdir</B> in <B>phormbase.txt</B><BR>\n";
      $ph_Abort = true;
    }
  }

/*
  Check $PHORM_RCONFIG */
  if ($PHORM_RCONFIG && !$PHORM_CONFIG) {
    if ($PHORM_URL && !$ph_Abort) Header("Location: $PHORM_URL");
    else {
      $ph_Errs.= "I'm sorry, this page only processes the contents of ".
                 "a form. You cannot access it directly.<BR><BR>\n";
      $ph_Abort = true;
    }
  }

/*
  Process the form-specific configuration file, if any */
  if ($PHORM_CONFIG) {
    if ($ph_debug3) echo "<B>NS:</B> PHORM_CONFIG ($PHORM_CONFIG)<BR>";
//  Strip any path info
    $PHORM_CONFIG = basename($PHORM_CONFIG);

//  If it's there and readable, include it; else generate an error.
    if (!is_readable($PHORM_CONFIG)) {
      $ph_Errs.= "Unable to open configuration file <B>$PHORM_CONFIG</B>.<BR><BR>\n";
      $ph_Abort = true;
    }
    else {
      include($PHORM_CONFIG);
    }
  }

/*
  If $PHORM_BASE was set in the config file, change to the specified dir */
  if ($PHORM_BASE) {
    if ($ph_debug3) echo "<B>NS:</B> ".strtoupper($PHORM_CONFIG).":phormbase<BR>";
    chdir($ph_Home);
    if (!@chdir($PHORM_BASE)) {
      $ph_Errs.= "Invalid directory <B>$PHORM_BASE</B> in <B>\$PHORM_CONFIG</B><BR>\n";
      $ph_Abort = true;
    }
  }
  unset($PHORM_BASE);

/*
  Restore only the declared configuration variables from the form */
  if ($ph_ForceDec)
    while (list($ph_var, $ph_val) = each($ph_varHold))
      if ($$ph_var == "{{FORM}}") $$ph_var = $ph_varHold[$ph_var];

/*
  Check for PHPMAIL_ variable names from previous versions */
  if ($PHPMAIL_ACK && !$PHORM_ACK) 
      $PHORM_ACK = $PHPMAIL_ACK; 
  if ($PHPMAIL_REQ && !$PHORM_REQ) 
      $PHORM_REQ = $PHPMAIL_REQ; 
  if ($PHPMAIL_TMPL && !$PHORM_TMPL) 
      $PHORM_TMPL = $PHPMAIL_TMPL; 
  if ($PHPMAIL_TO && !$PHORM_TO) 
      $PHORM_TO = $PHPMAIL_TO; 
  if ($PHPMAIL_FROM && !$PHORM_FROM) 
      $PHORM_FROM = $PHPMAIL_FROM; 
  if ($PHPMAIL_SUBJECT && !$PHORM_SUBJECT) 
      $PHORM_SUBJECT = $PHPMAIL_SUBJECT; 
  if ($PHPMAIL_LOG && !$PHORM_LOG) 
      $PHORM_LOG = $PHPMAIL_LOG; 
  if ($PHPMAIL_LOGVAR && !$PHORM_LOGVAR) 
      $PHORM_LOGVAR = $PHPMAIL_LOGVAR; 
  if ($PHPMAIL_RESP && !$PHORM_RESPOND) 
      $PHORM_RESPOND = $PHPMAIL_RESP; 
  if ($PHPMAIL_RFROM && !$PHORM_RESFROM) 
      $PHORM_RESFROM = $PHPMAIL_RFROM; 
  if ($PHPMAIL_RSUBJ && !$PHORM_RESUBJ) 
      $PHORM_RESUBJ = $PHPMAIL_RSUBJ;
  if ($PHPMAIL_REPLY && !$PHORM_RESRPLY) 
      $PHORM_RESRPLY = $PHPMAIL_REPLY; 

  if (is_array($PHORM_TMPL)) list($ph_key, $lPHORM_TMPL) = each($PHORM_TMPL);
  else $lPHORM_TMPL = $PHORM_TMPL;

  if (!$PHORM_LDELIM) $PHORM_LDELIM = "\t";

  $ph_Cards["mastercard"]       = "mcd";
  $ph_Cards["visa"]             = "vis";
  $ph_Cards["american express"] = "amx";
  $ph_Cards["discover"]         = "dsc";
  $ph_Cards["diners club"]      = "dnc";

  $ph_HTLink = 
    "<BR><BR><CENTER><FONT SIZE=1>".
    "<A HREF=\"http://www.holotech.net/\">$ph_Vers</A>".
    "</FONT></CENTER>";

  $ph_HTTag =
    "\n\n\n\n--\n$ph_Vers by Holotech Enterprises http://www.holotech.net/";

/* 
  Perform data validation */
  if ($PHORM_VALDEFS) {
    if ($ph_debug2) echo "<B><B>JS:</B></B> ValDefs ($PHORM_VALDEFS)<BR>";
    if (!$ph_vf = @fopen($PHORM_VALDEFS, "r"))
      $ph_Alerts.= "Unable to open validation file $PHORM_VALDEFS.\n";

    $ph_fidx = 1; $ph_ErrLevel = 0;
    while (!@feof($ph_vf)) {
      $ph_vlin = fgets($ph_vf, 256); $ph_vlin=trim($ph_vlin);
      if ($ph_debug41) echo "&nbsp;<B>vd:</B>$ph_vlin<BR>";

//    Parse the line for Criterion, Variable, Level and Comments
      list ($ph_Crit, $ph_Var, $ph_MsgLevel, $ph_Comments) 
        = split("\t", $ph_vlin, 4);
      if ($ph_debug411) echo "&nbsp;&nbsp;<B>vd:</B>$ph_Crit>$ph_Var>$ph_MsgLevel>$ph_Comments<BR>";

//    If there are any arguments, the actual Criterion will be in Args[0]
      $ph_Args = split(" ", $ph_Crit);
      if ($ph_Args[0]) $ph_Crit = $ph_Args[0];

      if ($ph_RULES && $ph_vlin > "") {
//      Get the value of Variable and check for any concatenated values.
        $ph_Val = $$ph_Var;
        if ($ph_ValCat) {
          $ph_Val = $ph_ValCat.$ph_Val;
          $ph_ValCat = "";
        }
        if ($ph_debug411) echo "&nbsp;&nbsp;<B>vd:</B>$ph_Crit [$ph_Var:$ph_Val]<BR>";

        if ($ph_Crit != "+") {
//        Load the message
          $ph_Msg = "";
          $ph_mlin = fgets($ph_vf, 256);
          if ($ph_debug41) echo "&nbsp;<B>vd:</B>$ph_mlin<BR>";
          while(!ereg("^###", $ph_mlin)) {
            $ph_Msg .= $ph_mlin;
            $ph_mlin = fgets($ph_vf, 256);
          if ($ph_debug41) echo "&nbsp;<B>vd:</B>$ph_mlin<BR>";
          }
        }
      }

      switch ($ph_Crit) {

      case "FILES" :
        $ph_FILES = true; $ph_RULES = false;
        break;

      case "RULES" :
        $ph_RULES = true; $ph_FILES = false;
        break;

      case "REQ" :
        if (!$ph_Val) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "EMAIL" :
        $ph_Match = (
          ereg("^.*<[[:alnum:]._-]+@[[:alnum:]_-]+(\.[[:alnum:]_-]+)?(\.[[:alnum:]]{1,3}){1,3}>$", $ph_Val)
          || ereg("^[[:alnum:]._-]+@[[:alnum:]_-]+(\.[[:alnum:]_-]+)?(\.[[:alnum:]]{1,3}){1,3}$",  $ph_Val)
        );
        if ($ph_Val && !$ph_Match) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "CCARD" :
        if (!$ph_Args[1])
          $ph_Alerts.= "CCARD criterion requires one argument.\n";

//      Strip any non-digits out of the card number
        $ph_Val = ereg_replace("[^[:digit:]]", "", $ph_Val);
        $ph_CType = $$ph_Args[1]; $ph_CType = strtolower($ph_CType);
        if (strlen($ph_CType) > 3) $ph_CType = $ph_Cards[$ph_CType];

        switch ($ph_CType) {

        case "mcd" :
          $ph_CVal = (ereg("^5[1-5].{14}$", $ph_Val) && ph_luhn($ph_Val));
          break;

        case "vis" :
          $ph_CVal = (ereg("^4.{15}$|^4.{12}$", $ph_Val) &&
                       ph_luhn($ph_Val));
          break;

        case "amx" :
          $ph_CVal = (ereg("^3[47].{13}$", $ph_Val) &&
                       ph_luhn($ph_Val));
          break;

        case "dsc" :
          $ph_CVal = (ereg("^6011.{12}$", $ph_Val) &&
                       ph_luhn($ph_Val));
          break;

        case "dnc" :
          $ph_CVal = (ereg("^30[0-5].{11}$|^3[68].{12}$", $ph_Val) &&
                       ph_luhn($ph_Val));
          break;

        case "jcb" :
          $ph_CVal = (ereg("^3.{15}$|^2131|1800.{11}$", $ph_Val) &&
                       ph_luhn($ph_Val));
          break;
        }

        if ($ph_Val && !$ph_CVal) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "PHONE" :
        $ph_Match = ereg("^(\(?[0-9]{3}\)?[ -])?[0-9]{3}[ -][0-9]{4}$", $ph_Val, $tkn);
        if ($ph_Val && !$ph_Match) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "RANGE" :
        if (!$ph_Args[2])
          $ph_Alerts.= "RANGE criterion requires two arguments.\n";

        if ($ph_Val && ($ph_Val < $ph_Args[1] || $ph_Val > $ph_Args[2])) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "ONEOF" :
        if (!$ph_Args[1])
          $ph_Alerts.= "ONEOF criterion requires at least one argument.\n";

        $ph_aidx = 1; $ph_Match = false;
        while ($ph_Args[$ph_aidx])
           if ($ph_Args[$ph_aidx++] == $ph_Val) $ph_Match = true;

        if ($ph_Val && !$ph_Match) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "NUMERIC" :
        if ($ph_Val && !ereg("^[-\+0-9][\.,0-9]*[0-9.]$", $ph_Val)) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "GT" :
        if (!$ph_Args[1])
          $ph_Alerts.= "GT criterion requires an argument.\n";

        if ($ph_Val && $ph_Val <= $ph_Args[1]) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "LT" :
        if (!$ph_Args[1])
          $ph_Alerts.= "LT criterion requires an argument.\n";

        if ($ph_Val && $ph_Val >= $ph_Args[1]) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "EQ" :
        if (!$ph_Args[1])
          $ph_Alerts.= "EQ criterion requires an argument.\n";

        if ($ph_Val && $ph_Val != $ph_Args[1]) {
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
        break;

      case "+" :
        $ph_ValCat .= $ph_Val;
        break;

      default:
        if ($ph_FILES) $ph_Files[$ph_fidx++] = $ph_Crit;
        if ($ph_RULES) $ph_Alerts.= "Invalid criterion: $ph_Crit\n";

      } // switch
    } // while (!feof)

    if ($ph_ErrLevel) {
      $ph_ErrFile = $ph_ErrLevel;
      $ph_MaxFile = sizeof($ph_Files);
      if ($ph_ErrFile > $ph_MaxFile) $ph_ErrFile = $ph_MaxFile;

//    If we can't open the error file, make our own.
      if (!$ph_ef = @fopen($ph_Files[$ph_ErrFile], "r")) {
        $ph_Alerts.= 
          "Unable to open validation error file $ph_Files[$ph_ErrFile].\n";

//        Parse the line for variable replacements.
          $ph_eline = $ph_ValMsg[$ph_ErrLevel];
          $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_eline, $ph_tkn);
          while ($ph_tkln) {
            $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
            $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
            $ph_eline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_eline);
            $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_eline, $ph_tkn);
          } /* ($ph_tkln) */
          $ph_eline = ereg_replace(":{:{", "{{", $ph_eline);
          $ph_ValMsg[$ph_ErrLevel] = $ph_eline;

        echo "<HMTL>\n".
             "<HEAD>\n".
             "<TITLE>Phorm Validation Error</TITLE>\n".
             "</HEAD>\n".
             "<BODY BGCOLOR=#FFC0C0 TEXT=#800000>\n".
             "<BR>\n\n".
             "$ph_ValMsg[$ph_ErrLevel]\n\n".
             "$ph_HTLink\n".
             "</BODY>\n".
             "</HTML>";
      }
      while(!@feof($ph_ef)) {
        $ph_eline = fgets($ph_ef, 1024);

//      Add our tag at the end of the file.
        if ((ereg("</BODY>", $ph_eline) || feof($ph_ef)) && !$PHORM_tagd) { 
          echo $ph_HTLink; echo "<!-- Generated by Phorm -->"; $PHORM_tagd=true; }
        if (ereg("<!-- Phorm Messages -->", $ph_eline))
          $ph_eline = $ph_ValMsg[$ph_ErrLevel];

//      Parse the line for variable replacements.
        $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_eline, $ph_tkn);
        while ($ph_tkln) {
          $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
          $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
          $ph_eline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_eline);
          $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_eline, $ph_tkn);
        } /* ($ph_tkln) */
        $ph_eline = ereg_replace(":{:{", "{{", $ph_eline);

        echo $ph_eline;
      } /* (!feof($ph_ef)) */
      @fclose($ph_ef);

      $ph_Abort = true;
    }

  } // if ($PHORM_VALDEFS)

/* If there's no ack template, redirect back to the calling form. Note that
   if $HTTP_REFERER is empty, the visitor will get a "302 Found" result
   (from Apache, anyway) */
  if (!$PHORM_ACK && !$ph_Abort) { 
    if (!$HTTP_REFERER) { 
      $ph_Alerts.= "Warning: No ack template specified, and \$HTTP_REFERER ".
               "is empty. Visitor received 302 Found status message.\n"; }
    Header("Location:$HTTP_REFERER");
  }

/*
  Open the acknowledgement template file. */
  if ($PHORM_ACK && !$ph_Abort)  {
    if ($ph_debug3) echo "NS: Open Ack Template <B>$PHORM_ACK</B>.<BR>";
    if (!$ph_af = @fopen($PHORM_ACK,"r")) {
      $ph_Errs.= "Unable to open acknowledgement template file ".
                 "<B>$PHORM_ACK</B>.<BR><BR>\n";
      $ph_Abort = true;
    }
  }

/*
  Open the autoresponder template file */
  if ($PHORM_RESPOND && !$ph_Abort) {
    if ($ph_debug3) echo "NS: Open Responder <B>$PHORM_RESPOND</B>.<BR>";
    if (!$ph_rf = @fopen($PHORM_RESPOND, "r"))
      $ph_Alerts.= "Unable to open autoresponder template file $PHORM_RESPOND.\n";
  }

/*
  Open the log file */
  if ($PHORM_LOG && $PHORM_LOGVAR && !$ph_Abort) {
    if ($ph_debug3) echo "NS: Open Log File <B>$PHORM_LOG</B>.<BR>";
    if (!$ph_lf = @fopen($PHORM_LOG, "a"))
      $ph_Alerts.= "Unable to open the log file $PHORM_LOG.\n";
  }

/*
  Check required fields */
  if ($PHORM_REQ && !$PHORM_VALDEFS && !$ph_Abort) {
    if ($ph_debug3) echo "NS: PHORM_REQ";
    $ph_ReqHdr = 
     "<HMTL><HEAD><TITLE>Phorm Required Field Missing</TITLE>".
     "<BODY BGCOLOR=#FFC0C0 TEXT=#800000><FONT SIZE=5>".
     "The following required fields are empty:</FONT><FONT SIZE=4><BR><BR>";
    $ph_ReqVars = explode(" ", $PHORM_REQ);
    $ph_idx = 0;
    while ($ph_ReqVars[$ph_idx]) {
//    echo "$ph_idx: $ph_ReqVars[$ph_idx] = ".$$ph_ReqVars[$ph_idx]."<BR>";
      if (!$$ph_ReqVars[$ph_idx]) {
        echo $ph_ReqHdr, $ph_ReqVars[$ph_idx], "<BR>"; 
        $ph_ReqHdr = "";
      }
      $ph_idx++;
    }
    if (!$ph_ReqHdr) {
      echo $ph_HTLink; echo "</FONT></BODY></HMTL>"; 
      exit;
    }
  }

/*
  Read the autoresponder template and email it back to the visitor */      
  if ($ph_rf && $PHORM_FROM && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Parse Autoresponder <B>$PHORM_RESPOND</B>.<BR>";
    $ph_sm = @popen($ph_sendmail,"w");

//  Send the headers
    fputs($ph_sm, "To: $PHORM_FROM\n");
    fputs($ph_sm, "From: $PHORM_RESFROM\n"); 
    fputs($ph_sm, "Subject: $PHORM_RESUBJ\n");
    if (PHORM_RESRPLY) {
     fputs($ph_sm, "Reply-to: $PHORM_RESRPLY\n");
    }
    fputs($ph_sm, "X-Mailer: PHP3/$ph_Vers\n\n");

    while(!feof($ph_rf)) {
      $ph_rline = fgets($ph_rf, 1024);

//    Parse the line for variable replacements.
      $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_rline, $ph_tkn);
      while ($ph_tkln) {
        $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
        $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
        $ph_rline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_rline);
        $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_rline, $ph_tkn);
      } // ($ph_tkln)
      $ph_rline = ereg_replace(":{:{", "{{", $ph_rline);

      fputs($ph_sm, $ph_rline);
    } // (!feof($ph_rf))

//  Add our tag at the end of the message.
    if ($ph_HTTag) { fputs($ph_sm, "$ph_HTTag"); }
    pclose($ph_sm);
    fclose($ph_rf);
  } // ($PHORM_RESPOND)

/*
  Log variables to the text log file. */
  if ($ph_lf && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Log to text file <B>$PHORM_LOG</B>.<BR>";
    $ph_LogVars = explode(" ", $PHORM_LOGVAR);
    $ph_idx = 0;
    $ph_LogLine = "";
    while ($ph_LogVars[$ph_idx]) {
      $ph_LogLine = $ph_LogLine.$$ph_LogVars[$ph_idx].$PHORM_LDELIM;
      $ph_idx++;
    }
    fputs($ph_lf, $ph_LogLine."\n");
    fclose($ph_lf);
  }

/*
  Log to MySQL Database */
  if ($PHORM_MYDBV && $PHORM_MYTABLE && $PHORM_MYVARS && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> MySQL Logger.<BR>";
    if (!is_readable($PHORM_MYDBV)) {
      $ph_Alerts.= "Unable to open Database variables file $PHORM_MYDBV.\n";
    }
    else {
      include($PHORM_MYDBV);
      if ($ph_debug71) echo "<B>Host:</B> $DHost <B>User:</B> $DUser <B>Pass:</B> $DPass <B>Base:</B> $DBase<BR>";
      $ph_ID = @mysql_connect($DHost, $DUser, $DPass);
      if (!$ph_ID) $ph_Alerts.= "Unable to connect to database $DBase.\n";
      else {
        $ph_selected = @mysql_select_db($DBase, $ph_ID);
        if (!$ph_selected) $ph_Alerts.= "Unable to select database $DBase.\n";
      }
      if ($ph_ID && $ph_selected) {
        $ph_CVPairs = split(",", $PHORM_MYVARS);
        $ph_idx = -1;
        $ph_Vals = "'";
        while ($ph_CVPairs[++$ph_idx]) {
          list($ph_Col, $ph_Val) = split("=", $ph_CVPairs[$ph_idx]);
          if ($ph_Cols) $ph_Cols.= ",";
          if (strlen($ph_Vals) > 1) $ph_Vals.= "','";
          $ph_Cols.= $ph_Col;
          $ph_Vals.= $$ph_Val;
        }
        $ph_Vals.= "'";
        $ph_QString = "insert into $PHORM_MYTABLE ($ph_Cols) values ($ph_Vals)";
        if ($ph_debug72) echo "<B>Q:</B> $ph_QString<BR>";
        $ph_Result = MySQL_Query($ph_QString, $ph_ID);
        if (!$ph_Result) $ph_Alerts.= "Error on query:\n   $ph_QString\n <B>MySQL says</B>: ".ereg_replace("[^A-z0-9'., ]","",MySQL_Error());
      }
    }
  }

/*
  Read the mail template file(s) and mail it (them) to the user */
  if ($lPHORM_TMPL && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Mail Template(s)<BR>";
    $mPHORM_TMPL = false; $ph_tmax = 25;
    if (sizeof($PHORM_TMPL) > $ph_tmax)
      $ph_Alerts.= "You may not have more than $ph_tmax email templates in \$PHORM_TMPL.\n";
    do {
      if ($ph_debug81) echo "Mail Template <B>$lPHORM_TMPL</B><BR>";
      if (!$ph_tf = @fopen($lPHORM_TMPL, "r"))
        $ph_Alerts.= "Unable to open mail template file $lPHORM_TMPL.\n";
      else {
        if (!$PHORM_FROM) { $PHORM_FROM = $PHORM_TO; }
        $ph_sm = @popen($ph_sendmail,"w");
        if (!$mPHORM_TMPL) {
          fputs($ph_sm, "To: $PHORM_TO\n");
          fputs($ph_sm, "From: $PHORM_FROM\n"); 
          fputs($ph_sm, "Subject: $PHORM_SUBJECT\n");
          fputs($ph_sm, "X-Mailer: PHP3/$ph_Vers\n\n");
        }
        while(!feof($ph_tf)) {
          $ph_tline = fgets($ph_tf, 1024);

//        Parse the line for variable replacements.
          $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_tline, $ph_tkn);
          while ($ph_tkln) {
            $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
            $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
            $ph_tline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_tline);
            $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_tline, $ph_tkn);
          } // ($ph_tkln)
          $ph_tline = ereg_replace(":{:{", "{{", $ph_tline);

          fputs($ph_sm, "$ph_tline");
        } // (!feof($ph_tf))
        fputs($ph_sm, $ph_HTTag);
        fclose($ph_tf);
        pclose($ph_sm);
      } // if (!$ph_tf)/else

//    If PHORM_TMPL is an array, get the next element.
      if (is_array($PHORM_TMPL))
        $mPHORM_TMPL = (list($ph_key, $lPHORM_TMPL) = each($PHORM_TMPL));
    } while ($mPHORM_TMPL && --$ph_tmax);
  } // if ($lPHORM_TMPL)

/*
  Read the ack template and output it. Temporarily changing {{ and }} in
  the visitor's input to :{:{ and :}:} prevents them from displaying 
  internal variables, such as $DPass for example. */
  if ($ph_af && !$ph_Abort)  {
    if ($ph_debug2) echo "<B>JS:</B> Ack Template <B>$PHORM_ACK</B><BR>";
    while(!feof($ph_af)) {
      $ph_aline = fgets($ph_af, 1024);

//    Add our tag at the end of the file.
      if ((ereg("</BODY>", $ph_aline) || feof($ph_af)) && !$PHORM_tagd) { 
        echo $ph_HTLink; echo "<!-- Generated by Phorm -->"; $PHORM_tagd=true; }

//    Parse the line for variable replacements.
      $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_aline, $ph_tkn);
      while ($ph_tkln) {
        $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
        $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
        $ph_aline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_aline);
        $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_aline, $ph_tkn);
      } /* ($ph_tkln) */
      $ph_aline = ereg_replace(":{:{", "{{", $ph_aline);

      echo $ph_aline;
    } // (!feof($ph_af))
    fclose($ph_af);
  } // (PHORM_ACK)

/*
  Display any fatal error messages to the visitor, along with internal
  alerts, if PHORM_ALERTTO is not defined. */
  if ($ph_Errs || ($ph_Alerts && ($ph_debug1 || !$PHORM_ALERTTO))) {
    echo "<HMTL>\n".
         "<HEAD>\n".
         "<TITLE>Phorm Error</TITLE>\n".
         "</HEAD>\n".
         "<BODY BGCOLOR=#FFC0C0 TEXT=#800000>\n".
         "\n";
    if ($ph_Errs) echo "<FONT SIZE=5>ERROR<BR><BR></FONT>\n".
                       "$ph_Errs\n";
    if ($ph_Alerts && ($ph_debug1 || !$PHORM_ALERTTO)) {
      $ph_Alerts = nl2br($ph_Alerts);
      echo "Alerts:<BR> $ph_Alerts";
    }
    echo "$ph_HTLink\n".
         "</BODY></HTML>";
  }

/*
  Email any alerts and errors to the user, if an address was specified. */
  if (($ph_Alerts || $ph_Errs) && $PHORM_ALERTTO) {
    $ph_Errs = ereg_replace("</*[A-z]*>", "", $ph_Errs);
    $ph_sm = @popen($ph_sendmail,"w");
    fputs($ph_sm, "To: $PHORM_ALERTTO\n");
    fputs($ph_sm, "From: Phorm Processor <Phorm.Processor>\n"); 
    fputs($ph_sm, "Subject: Phorm Alert\n");
    fputs($ph_sm, "X-Mailer: PHP3/$ph_Vers\n\n");
    fputs($ph_sm, "Internal Alerts:\n");
    fputs($ph_sm, "$ph_Alerts\n");
    if ($ph_Errs) {
      fputs($ph_sm, "Fatal errors displayed to visitor:\n");
      fputs($ph_sm, "$ph_Errs\n");
    }
    fputs($ph_sm, "Phorm Variables:\n");
    while (list($ph_key, $ph_val) = each($GLOBALS)) {
      if (ereg("^PHORM_", $ph_key)) {
        fputs($ph_sm, "$ph_key: $ph_val\n");
      }
    }
    reset($GLOBALS);
    fputs($ph_sm, $ph_HTTag);
    pclose($ph_sm);
  }

/*
  Email system errors to the administrator, if an address was specified. */
  if ($ph_Admin && $PHORM_ADMIN) {
    $ph_Admin = ereg_replace("</*[A-z]*>", "", $ph_Admin);
    $ph_sm = @popen($ph_sendmail,"w");
    fputs($ph_sm, "To: $PHORM_ADMIN\n");
    fputs($ph_sm, "From: Phorm Processor <Phorm.Processor>\n"); 
    fputs($ph_sm, "Subject: Phorm System Error\n");
    fputs($ph_sm, "X-Mailer: PHP3/$ph_Vers\n\n");
    fputs($ph_sm, "Phorm System Error:\n");
    fputs($ph_sm, "$ph_Admin\n");
    fputs($ph_sm, "Global Variables:\n");
    while (list($ph_key, $ph_val) = each($GLOBALS))
        fputs($ph_sm, "$ph_key: $ph_val\n");
    reset($GLOBALS);
    fputs($ph_sm, $ph_HTTag);
    pclose($ph_sm);
  }
?>