<? $ph_ForceDec = true;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * Copyright (c) 1999 Holotech Enterprises (phorm@holotech.net)
 *
 * This is a trimmed-down version of the popular Phorm script, with only
 * email and acknowledgement functions. The full version of Phorm is
 * available at http://www.holotech.net/scripts.html, as well as full
 * documentation and example files for Phorm Jr.
 *
 * You may freely distribute this script as-is and without modifications.
 * You may use this script freely, and modify it for your own purposes.
 * There is no charge for this script, but if you like it, I'd be happy to
 * hear about it at phorm@holotech.net.
 *
 * I hope you find this program useful. Aloha.
 *                                                 Alan Little
 *                                                 March 2000
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
  Phorm Jr. configuration variables. For more detail, see the full documentation
  available at http://www.holotech.net/scripts.html

  $PHORM_NAME:    The name of the form. Phorm Jr. appends .phm to this, and
                  looks for a configuration file of that name.
  $PHORM_ALERTTO: Email address to send internal error messages to, such as
                  unable to open the log file or database. If it is not
                  specified, all error messages will be displayed to the
                  visitor. If it is specified, only errors which affect the
                  visitor's operation will be displayed.
  $PHORM_ACK:     An HTML file, containing variable substitutions, to output
                  to the user after form submission. If unspecified, no ack is
                  displayed, and Phorm Jr. attempts to redirect the user back
                  to the URL of the form.
  $PHORM_REQ:     A space-delimited list of all required fields.
  $PHORM_TMPL:    Text template file for formatting contents to be emailed to
                  user. If not specified, contents are not mailed.
  $PHORM_TO:      Email address to send the contents to. It is required if
                  PHORM_TMPL is specified.
  $PHORM_FROM:    Email address for the FROM field of the emailed contents.
                  NOTE: If this is blank, it will be set to the same as PHORM_TO.
  $PHORM_SUBJECT: Subject field for emailed contents.
*/

/*
  Unset any ph_ variables to prevent anyone from trying to sneak something in */
  while (list($ph_var, $ph_val) = each($GLOBALS))
    if (ereg("^ph_", $ph_var) && !ereg("^ph_ForceDec$", $ph_var))
      unset($$ph_var);
  reset($GLOBALS);

  $ph_Vers = "Phorm Jr. v1.0";
  $ph_Home = dirname(getenv("PATH_TRANSLATED"));

/*
  Record the configuration variables passed from the form, then unset them */
  if ($ph_ForceDec) {
    while (list($ph_var, $ph_val) = each($GLOBALS))
      if (ereg("^PHORM_", $ph_var)) {
        $ph_varHold[$ph_var] = $ph_val;
        unset($$ph_var);
      }
  }
  reset($GLOBALS);

/*
  Restore $PHORM_NAME and process the configuration file */
  $PHORM_NAME = $ph_varHold["PHORM_NAME"];
  $ph_Config = basename($PHORM_NAME).".phm";
  if ($ph_debug3) echo "<B>NS:</B> Config file $ph_Config<BR>";
  if (!is_readable($ph_Config)) {
    $ph_Errs.= "Unable to open configuration file $ph_Config.<BR><BR>\n";
    $ph_Abort = true;
  }
  else {
    include ("$ph_Config");
  }

/*
  Restore only the declared PHORM_ variables from the form */
  if ($ph_ForceDec)
    while (list($ph_var, $ph_val) = each($ph_varHold))
      if ($$ph_var == "{{FORM}}") $$ph_var = $ph_varHold[$ph_var];

  $ph_HTLink =
    "<BR><BR><CENTER><FONT SIZE=1>".
    "<A HREF=\"http://www.holotech.net/\">$ph_Vers</A>".
    "</FONT></CENTER>";

  $ph_HTTag =
    "\n\n\n\n--\n$ph_Vers by Holotech Enterprises http://www.holotech.net/";

/* If there's no ack template, redirect back to the calling form. Note that
   if $HTTP_REFERER is empty, the visitor will get a "302 Found" result
   (from Apache, anyway) */
  if (!$PHORM_ACK && !$ph_Abort) {
    if (!$HTTP_REFERER) {
      $ph_Alerts.= "Warning: No ack template specified, and \$HTTP_REFERER ".
               "is empty. Visitor received 302 Found status message.\n"; }
    Header("Location:$HTTP_REFERER");
  }

/*
  Open the acknowledgement template file. */
  if ($PHORM_ACK && !$ph_Abort)  {
    if ($ph_debug3) echo "NS: Open Ack Template <B>$PHORM_ACK</B>.<BR>";
    if (!$ph_af = @fopen($PHORM_ACK,"r")) {
      $ph_Errs.= "Unable to open acknowledgement template file ".
                 "<B>$PHORM_ACK</B>.<BR><BR>\n";
      $ph_Abort = true;
    }
  }

/*
  Open the mail template file. */
  if ($PHORM_TMPL && !$ph_Abort)  {
    if ($ph_debug3) echo "NS: Open Mail Template <B>$PHORM_TMPL</B>.<BR>";
    if (!$ph_tf = @fopen($PHORM_TMPL,"r")) {
      $ph_Alerts.= "Unable to open mail template file <B>$PHORM_TMPL</B>.<BR><BR>\n";
    }
  }

/*
  Check required fields */
  if ($PHORM_REQ && !$ph_Abort) {
    if ($ph_debug3) echo "NS: PHORM_REQ";
    $ph_ReqHdr =
     "<HMTL><HEAD><TITLE>Phorm Required Field Missing</TITLE>".
     "<BODY BGCOLOR=#FFC0C0 TEXT=#800000><FONT SIZE=5>".
     "The following required fields are empty:</FONT><FONT SIZE=4><BR><BR>";
    $ph_ReqVars = explode(" ", $PHORM_REQ);
    $ph_idx = 0;
    while ($ph_ReqVars[$ph_idx]) {
      if (!$$ph_ReqVars[$ph_idx]) {
        echo $ph_ReqHdr, $ph_ReqVars[$ph_idx], "<BR>";
        $ph_ReqHdr = "";
      }
      $ph_idx++;
    }
    if (!$ph_ReqHdr) {
      echo $ph_HTLink; echo "</FONT></BODY></HMTL>";
      $ph_Abort = true;
    }
  }

/*
  Read the mail template file and mail it to the user */
  if ($ph_tf && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Mail Template <B>$PHORM_TMPL</B><BR>";
    if (!$PHORM_FROM) $PHORM_FROM = $PHORM_TO;
    $ph_Message = "";

    while(!feof($ph_tf)) {
      $ph_tline = fgets($ph_tf, 1024);

//    Parse the line for variable replacements.
      $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_tline, $ph_tkn);
      while ($ph_tkln) {
        $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
        $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
        $ph_tline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_tline);
        $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_tline, $ph_tkn);
      } // ($ph_tkln)
      $ph_tline = ereg_replace(":{:{", "{{", $ph_tline);

      $ph_Message.= $ph_tline;
    } // (!feof($ph_tf))
    $ph_Message.= $ph_HTTag;
    fclose($ph_tf);

    $ph_Headers = "From: $PHORM_FROM\n".
                  "X-Mailer: PHP3/$ph_Vers";
    Mail($PHORM_TO,
         $PHORM_SUBJECT,
         $ph_Message,
         $ph_Headers);

  } // if ($ph_tf)

/*
  Read the ack template and output it. Temporarily changing {{ and }} in
  the visitor's input to :{:{ and :}:} prevents them from displaying
  internal variables. */
  if ($ph_af && !$ph_Abort)  {
    if ($ph_debug2) echo "<B>JS:</B> Ack Template <B>$PHORM_ACK</B><BR>";
    while(!feof($ph_af)) {
      $ph_aline = fgets($ph_af, 1024);

//    Add our tag at the end of the file.
      if ((ereg("</BODY>", $ph_aline) || feof($ph_af)) && !$ph_tagd) {
        echo $ph_HTLink; echo "<!-- Generated by Phorm -->"; $ph_tagd=true; }

//    Parse the line for variable replacements.
      $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_aline, $ph_tkn);
      while ($ph_tkln) {
        $ph_sub = substr($ph_tkn[0], 2, $ph_tkln-4);
        $$ph_sub = ereg_replace("{{", ":{:{", $$ph_sub);
        $ph_aline = ereg_replace($ph_tkn[0], $$ph_sub, $ph_aline);
        $ph_tkln = ereg("{{[A-z0-9_]*}}", $ph_aline, $ph_tkn);
      } /* ($ph_tkln) */
      $ph_aline = ereg_replace(":{:{", "{{", $ph_aline);

      echo $ph_aline;
    } // (!feof($ph_af))
    fclose($ph_af);
  } // (PHORM_ACK)

/*
  Display any fatal error messages to the visitor, along with internal
  alerts if PHORM_ALERTTO is not defined. */
  if ($ph_Errs || ($ph_Alerts && ($ph_debug1 || !$PHORM_ALERTTO))) {
    echo "<HMTL>\n".
         "<HEAD>\n".
         "<TITLE>Phorm Error</TITLE>\n".
         "</HEAD>\n".
         "<BODY BGCOLOR=#FFC0C0 TEXT=#800000>\n".
         "\n";
    if ($ph_Errs) echo "<FONT SIZE=5>ERROR<BR><BR></FONT>\n".
                       "$ph_Errs\n";
    if ($ph_Alerts && ($ph_debug1 || !$PHORM_ALERTTO)) {
      $ph_Alerts = nl2br($ph_Alerts);
      echo "Alerts:<BR> $ph_Alerts";
    }
    echo "$ph_HTLink\n".
         "</BODY></HTML>";
  }

/*
  Email any alerts and errors to the user, if an address was specified. */
  if (($ph_Alerts || $ph_Errs) && $PHORM_ALERTTO) {
    $ph_Errs = ereg_replace("</*[A-z]*>", "", $ph_Errs);
    $ph_Message = "Internal Alerts:\n".
                  "$ph_Alerts\n";

    if ($ph_Errs) {
      $ph_Message.= "Fatal errors displayed to visitor:\n".
                    "$ph_Errs\n";
    }
    $ph_Message.= "Phorm and form Variables:\n";
    while (list($ph_key, $ph_val) = each($GLOBALS)) {
      if (!ereg("^ph_", $ph_key)) {
        $ph_Message.= "$ph_key: $ph_val\n";
      }
    }
    reset($GLOBALS);
    $ph_Message.= $ph_HTTag;

    $ph_Headers = "From: Phorm Processor <Phorm.Processor>\n".
                  "X-Mailer: PHP3/$ph_Vers";

    Mail($PHORM_ALERTTO,
         "Phorm Alerts",
         $ph_Message,
         $ph_Headers);
  }

/*
Internal Variables:

Abort    = Signals the rest of the script to stop processing
af       = File handle of the acknowledgement template
Alerts   = Internal alert message(s)
aline    = A line from the ack template file
Errs     = Fatal error messages that are displayed to the visitor
ForceDec = If true, the user must explicitly declare PHORM_ variables from the form
Home     = The user's Phorm directory
HTLink   = The link to holotech.net
HTTag    = The Phorm/Holotech tag for the end of email messages
idx      = General-purpose index variable
key      = A throwaway to hold the key while traversing an array with each()
ReqHdr   = HTML header to output if a variable in $PHORM_REQ is missing
ReqVars  = The list of variables required in $PHORM_REQ
tf       = File handle for the email template file
tkln     = Holds a line while it's being parsed for variable substitutions
tkn      = Holds the name of a variable to be substituted into the line
tline    = A line from the email template file
varHold  = An array to hold $PHORM_ variables passed from the form
val      = Holds variable values while processing the ForceDec directive
var      = Holds variable names while processing the ForceDec directive
Vers     = The current version of Phorm
*/
?>