

<script language="php">

/*********************************************************************************
                                php3guest
                                v. 1.6.5
                       (c) Bastian Friedrich 2000

http://www.bastian-friedrich.de/comp/guestbook/

php3guest is a web frontend useing mySQL as a backend to provide a guestbook for
your web page.

php3guest is developed under the GPL. Please read the COPYING for further info.

*********************************************************************************/

//////////////////////////////////////////////////////////////////////////////////
// A list of possible arguments, some of which may and will have to be passed to
// successor pages:
// $act       - view, insert, submit, askpass
// $viewhtml  - 0, 1
// $language  - any php3guest.language.inc file available
// $from      - first entry to view in view- or edit mode
// $pass      - owner's password if available

// \"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass\"

/*------------------------  ------------------------*/
/*------------------------ Script starts HERE! ------------------------*/

  // Read Config File
  require("php3guestrc");

  // read language definition file
  $language = (($language) && (file_exists("php3guest.$language.inc"))) ? $language : $defaultLanguage;

  if (!file_exists("php3guest.$language.inc")) die("Default Language is not available!");
  require("php3guest.$language.inc");


/*------------------------ Functions ------------------------*/
/*------------------------ Open Database ------------------------*/

function openDatabase() {

  // import global variables
  global $db_host,
         $db_user,
         $db_pass,

         $db_db;

// open database connection and select database
  mysql_connect($db_host,$db_user,$db_pass) || die("Could not contact mySQL!");
  mysql_select_db($db_db) || die("Connected mySQL, but database is unavailable!");
}

/*------------------------ Print the entry form ------------------------*/

function printInsertForm($name = "", $mail = "", $url = "http://", $hp = "", $private = "", $entry = "", $editid = "", $update = "") {

  // import global variables
  global $scriptname,
	 $language;

  // read language definition file
  require("php3guest.$language.inc");

  // print header
  print('<p>');
  print(($update) ? $changeGreeting : $insertGreeting);
  print('</p>');

  // add values in edit mode
  $private_str = ($private) ? " checked " : "";

  // print the actual form inserting the labels from config and eventually passed fields in edit mode
  print('
<form action="'.$scriptname."?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass".'&act=submit" method="post">
<input type="hidden" name="editid" value="'.$editid.'">
<input type="hidden" name="update" value="'.$update.'">
  <table>
    <tr>
      <td><p>'.$labelInsertName.'</p></td>
      <td><input name="name" size="50" maxlength="50" value="'.$name.'"></td>
    </tr>
    <tr>
      <td><p>'.$labelInsertMail.'</p></td>
      <td><input name="mail" size="50" maxlength="100" value="'.$mail.'"></td>
    </tr>
    <tr>
      <td><p>'.$labelInsertURL.'</p></td>
      <td><input name="url" size="50" maxlength="100" value="'.$url.'"></td>
    </tr>
    <tr>
      <td><p>'.$labelInsertHP.'</p></td>
      <td><input name="hp" size="50" maxlength="100" value="'.$hp.'"></td>
    </tr>
  </table>

  <p>'.$labelInsertPrivate.'<input type=checkbox name="private" '.$private_str.' value="1"></p>

  <p>'.$labelInsertEntry.'</p><p><textarea name="entry" rows="15" cols="60" wrap="virtual">'.$entry.'</textarea></p>

  <input type="submit" value="'.$labelInsertSubmit.'">
  <input type="reset" value="'.$labelInsertReset.'">
  
</form>
');
}

/*------------------------ put submitted data into the database ------------------------*/

function submitThis() {

  // import global variables

  global $scriptname,
         $viewhtml,
         $name,
         $mail,
         $url,
         $hp,
         $private,
         $entry,
         $update,
         $editid,
         $db_table,
         $mailEntries,
         $mailEntriesSubject,
         $mailEntriesTo,
	 $mailEntriesFrom,
         $language;

  // read language definition file
  require("php3guest.$language.inc");

  // Is there any data to submit? We don't want empty entries
  if (!$name || !$entry) {
    print('<p>'.$insufficientEntry.'</p>');
  } else {

    // take away predefined "http://" of the url, if nothing was added
    if ($url == "http://") $url = "";

    // Check for magic_quotes settings in PHP and add or remove slashes
    if (get_magic_quotes_gpc()) {
      // Remove Slashes from output data
      $_name  = $name;  $name  = StripSlashes($name);
      $_mail  = $mail;  $mail  = StripSlashes($mail);
      $_url   = $url;   $url   = StripSlashes($url);
      $_hp    = $hp;    $hp    = StripSlashes($hp);
      $_entry = $entry; $entry = StripSlashes($entry);
    } else {
      // Escape any '," and such. MySQL would not like this. Create date and "private entry" string, depending on checkbox
      $_name    = AddSlashes($name);
      $_mail    = AddSlashes($mail);
      $_url     = AddSlashes($url);
      $_hp      = AddSlashes($hp);
      $_entry   = AddSlashes($entry);
    }
    $_private = ($private) ? $labelYes : $labelNo;
    $_idate   = date("Y-m-d H:i:s");

    // MySQL does not like it being passed "nothing" as a value, so set private to "0", if it was not set.
    if ($private != 1) $private = 0;

    // Our insertion/update query string
    if ($update)
      $query = "update $db_table set name='$_name', mail='$_mail', url='$_url', hp='$_hp', private=$private, entry='$_entry' where eid=$editid;";
    else
      $query = "insert into $db_table values ('','$_name','$_mail','$_url','$_hp',$private,'$_idate','$_entry');";

    // Insert/update or die
    mysql_query($query) || die('Error submitting data! Please contact administrator or try again!');

    // mail the entry to the owner, if turned on in config file
    if ($mailEntries) 
      mail($mailEntriesTo, $mailEntriesSubject, "
        $labelInsertName $name
        $labelInsertMail $mail
        $labelInsertURL $url
        $labelInsertHP $hp
        $labelInsertPrivate $_private
        $labelInsertDate $_idate
        $labelInsertEntry $entry",
	"From: $mailEntriesFrom");

    // escape eventual html content in the entry if user wishes
    if (!$viewhtml) $entry = htmlentities($entry);

    // change linebreaks to html paragraphs or linebreaks
    $entry = str_replace("\n.\n", "</p><p>", $entry);
    $entry = str_replace("\n", "<br>", $entry);

    // Output submitted data
    print('
<p>'.$submitGreeting.'</p>
<p>
'.$labelInsertName.htmlentities($name).'<br>
'.$labelInsertMail.htmlentities($mail).'<br>
'.$labelInsertURL.htmlentities($url).'<br>
'.$labelInsertHP.htmlentities($hp).'<br>
'.$labelInsertPrivate.$_private.'<br>
'.$labelInsertDate.$_idate.'<br>
'.$labelInsertEntry.$entry.'
</p>
<p><a href="'."$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass".'">'.$submitBack.'</a></p>
');

  }
}

/*------------------------ View Single Entry -------------------*/

function viewSingleEntry($name, $mail, $url, $hp, $private, $idate, $entry) {

  // import global variables
  global $pass,
         $ownerPass,
         $viewhtml,
         $linkNewWindow,
         $language;

  $name = htmlentities($name);
  $mail = htmlentities($mail);
  $url  = htmlentities($url);
  $hp   = htmlentities($hp);

  // read language definition file
  require("php3guest.$language.inc");

  // if the visitor provided a mail address, set it as a "mailto:" - a-href in $_name
  $_name = $labelViewName;
  if ($mail) $_name .= '<a href="mailto:'.$mail.'">';
  $_name .= $name;
  if ($mail) $_name .= '</a>';
  $_name .= "<br>";

  // if the visitor provided a homepage, set it as a <a href>. Use it's name as a link if there is any, otherwise take the url
  $_hp = "";
  if ($url) {
    $_hp = "$labelViewHP<a href=\"$url\"";
    if ($linkNewWindow) $_hp .= ' target="_new"';
    $_hp .= ">";
    $_hp .= ($hp) ? $hp : $url;
    $_hp .= "</a><br>";
  }

  // if entry is private, check for a password (which must be correct by now, if it is set)
  // output entry or a message that this is a private entry
  $_entry = "";
  if ($private && (!$pass)) {
    $_entry = $notifyPrivateEntry;
    $_entry .= "<br><a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass&act=askpass&nextact=view\">";
    $_entry .= $privateLink;
    $_entry .= "</a>";
  } else {
    if ($private) $_entry = "$privateInfo</p><p>";
    $_entry .= ($viewhtml) ? $entry : htmlentities($entry);
  }

  // Escape any linebreaks as HTML paragraphs or linebreaks
  $_entry = str_replace("\n.\n", "</p><p>", $_entry);
  $_entry = str_replace("\n", "<br>", $_entry);

  ///////////////////////
  // output data

      print("
<p>
$labelViewDate $idate<br>
$_name
$_hp
<p>$labelViewEntry</p>
<p>$_entry
</p>");

}

/*------------------------ View Entries ------------------------*/

function viewEntries() {

  // import global variables
  global $from,
         $entriesPerPage,
         $act,
         $scriptname,
         $db_table,
         $noEntries,
         $ownerPass,
         $pass,
         $language,
         $possibleLanguages,
         $usableWithoutJavascript,
         $adminSubmit;

  // read language definition file
  require("php3guest.$language.inc");

  // Are we administrating without proper password?
  if (($act == "admin") && (!$pass)) {
    print("<p>$adminNoPass<br>");
    print("<a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass&act=askpass&nextact=admin\">$adminNoPassLink</a></p>");
  } else {

    // query the database
    $query = "select * from $db_table order by idate desc;";
    $arowid = mysql_query($query);

    // are there any entries?
    if (($arowid == 0) || (mysql_num_rows($arowid) == 0)) {
      print("<p>$noEntries</p>");
    } else {

      // Are we viewing or administrating the entries?
      if ($act != "admin")
        print("<p><a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass&act=admin\">$adminLink</a></p>\n");

      // Print drop down box

      if (strlen($possibleLanguages) > 0) {
        print('<form>'.$labelLanguage.'<select name="language" size="1" onchange="submit()">');
        $possLang = strtok($possibleLanguages, " ");
        while ($possLang) {
          if ($language == $possLang) $sel = "selected";
          print("<option value=\"$possLang\" $sel>$possLang</option>");
          $sel="";
          $possLang = strtok(" ");
        }
        print('</select>');
       // Give people without javascript a chance to change the language
       if ($usableWithoutJavascript)
               print('&nbsp;<input type="submit" value="'.$adminSubmit.'">');
       print('</form>');
      }

      // calculate the entries from and to which we want to view
      $from = ($from) ? $from : 0;
      $to = min($from+$entriesPerPage-1, mysql_num_rows($arowid)-1);

      // Tell visitor which entries he is seeing
      $d_from = $from+1;
      $d_to   = $to+1;
      print("<p>$labelViewEntryIDs $d_from - $d_to</p>");

      // Bogus request? This really should not happen - anyway. Don't want php3 errors on screen.
      if ($from < 0 || $from > mysql_num_rows($arowid)-1) {
        die('<p>Ouch! You are requesting entries that do not exist! Go away!</p>');
      }

      // Seek to the first entry to be viewed
      mysql_data_seek($arowid, $from);

      $nr = 0;

      // In admin mode, we want a table of selectable entries as a form
      if ($act == "admin")
        print("<form action=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass&act=edit\" method=\"post\"><table border=\"1\">");
      else
        print("<hr>");

      // read $entriesPerPage entries
      while ($nr < $entriesPerPage) {

        // is there such an entry? If not -> out of this loop (Well, this really should not happen...
        if (!$arow = mysql_fetch_row($arowid)) break;

        // create radio buttons and table cells in admin mode 
        if ($act == "admin") print("<tr><td><input type=\"radio\" name=\"editid\" value=\"$arow[0]\"></td><td>");

        // Display entry with data from database
        viewSingleEntry($arow[1], $arow[2], $arow[3], $arow[4], $arow[5], $arow[6], $arow[7]);

        // seperate entries (ruler or cell)
        print(($act == "admin") ? "</td></tr>" : "<hr>");

        $nr++;
      }

      // finish table and form in admin mode: radio buttons to select next step and submission button
      if ($act == "admin")
        print("</table>
        <p>
        <input type=\"radio\" name=\"editremove\" checked value=\"1\">$adminEdit&nbsp;</input><input type=\"radio\" name=\"editremove\" value=\"2\">$adminRemove</input><br>
        <input type=\"submit\" value=\"$adminSubmit\"></input>
        </p>
        </form>");

      ///////////////////////
      // Next and Last Page Links

      print("<p>$labelViewEntryIDs: ");

      // make sure we can selected newer entries
      $newfrom=0;
      print("<p>");
      while ( $newfrom < $from ) {
        $newto = min($newfrom+$entriesPerPage-1,$from-1);

        // print the link
        $d_newfrom = $newfrom+1;
        $d_newto = $newto+1;
        print("[ <a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$newfrom&pass=$pass&act=$act\">
               $d_newfrom - $d_newto</a> ] ");
        $newfrom = $newto+1;
      }

      print("[ $d_from - $d_to ]");

      // are there any older entries?
      $newto=$to;
      while ($newto < mysql_num_rows($arowid)-1) {
        // start and end?
        $newfrom = $newto+1;
        $newto = min(mysql_num_rows($arowid), $newfrom+$entriesPerPage)-1;
        // print the link
        $d_newfrom = $newfrom+1;
        $d_newto = $newto+1;
        print("[ <a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$newfrom&pass=$pass&act=$act\">
               $d_newfrom - $d_newto</a> ] ");
      }
      print("</p>");
    }
  }
}

/*------------------------ askPass ------------------------*/

function askPass() {

  // import global variables
  global $from,
         $view,
	 $viewhtml,
         $language,
         $nextact,
         $scriptname;


  // read language definition file
  require("php3guest.$language.inc");

  // print a little form using the labels from the config file
  // php3 will be glad to read $pass from a HTML POST or as part of the URL - so we
  // do not have to do anything for this :))))

  print("
<p>
<form action=\"$scriptname?language=$language&from=$from&act=$nextact\" method=\"post\">
$labelPassPass <input type=\"password\" name=\"pass\" size=\"20\" maxlength=\"20\"><br>
<input type=\"radio\" name=\"viewhtml\" value=\"0\"".($viewhtml ? "" : " checked")."> $labelNoHTML<br>
<input type=\"radio\" name=\"viewhtml\" value=\"1\"".($viewhtml ? " checked" : "")."> $labelHTML<br>
<input type=\"submit\" value=\"$labelPassSubmit\">
</form>
</p>");

}

/*------------------------  ------------------------*/

function editEntry() {

  // import global variables
  global $from,
         $entriesPerPage,
         $act,
         $scriptname,
         $db_table,
         $noEntries,
         $ownerPass,
         $pass,
         $language,
         $editid,
         $editremove;

  // read language definition file
  require("php3guest.$language.inc");

  if (!$editid) 
    print("<p>$noEditSelection</p><p><a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass&act=admin\">$adminLink</a></p>");
  else {
    // check for password
    if (!$pass) {
      // no? print error message
      print("<p>$adminNoPass<br>");
      print("<a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass&act=askpass&nextact=admin\">$adminNoPassLink</a></p>");
    } else {
      // yep - do we want to remove an entry or edit one?
      switch ($editremove) {
        case 1 :
          // edit mode: get row from database and pass arguments to insert form if available
          $query = "select * from $db_table where eid = $editid";
          $arowid = mysql_query($query);
          if ($arowid) {
            $arow = mysql_fetch_row($arowid);
            printInsertForm($arow[1], $arow[2], $arow[3], $arow[4], $arow[5], $arow[7], $arow[0], 1); 
          } else die("Ooops! Severe database error!");
          break;

        case 2 :
          // remove mode: remove row from database, if possible and print status message.
          $query = "delete from $db_table where eid=$editid";
          $queryresult = mysql_query($query);
          if ($queryresult)
            print("<p>$labelSuccessfullRemove</p>");
          else die("Ooops! Severe database error!");
          print("<p><a href=\"$scriptname?viewhtml=$viewhtml&language=$language&from=$from&pass=$pass\">$submitBack</a></p>");
          break;
      }
    }
  }
}

/*------------------------  ------------------------*/
/*------------------------ Main ------------------------*/
/*------------------------  ------------------------*/

  // Turn off magic quotes
  set_magic_quotes_runtime(0);

  // Print page header
  print($pageHeader);

  // Password set? Is it correct? Else die at an earlier stage
  if ($pass && $pass != $ownerPass) die($wrongPass.$pageFooter);

  // Well... Why am I commenting all this stuff? It IS self explaining...
  openDatabase();

  // Evaluate viewhtml parameter if given
  if (!isset($viewhtml) || $viewhtml == "") $viewhtml = $viewHTMLentries;

  // Well, what shall we do at all?
  switch ($act) {
  // insert an entry
    case "insert" :
      printInsertForm();
      break;

  // submit an entry
    case "submit" :
      submitThis();
      break;

  // ask for a owner password
    case "askpass" :
      askPass();
      break;

  // Edit an entry
    case "edit" :
      editEntry();
      break;

  // else we want to view or admin all this stuff
    default :
      viewEntries();
      break;

    }

  // output page footer
  print($pageFooter);

</script>


